SystemOrganization addCategory: #'System-Settings-Core'!
SystemOrganization addCategory: #'System-Settings-Morphic'!
SystemOrganization addCategory: #'System-Settings-Pragma'!
SystemOrganization addCategory: #'System-Settings-Browser'!
SystemOrganization addCategory: #'System-Settings-Style'!
SystemOrganization addCategory: #'System-Settings-Menu-Core'!
SystemOrganization addCategory: #'System-Settings-Menu-Assembler'!
SystemOrganization addCategory: #'System-Settings-Menu-Browser'!
SystemOrganization addCategory: #'System-Settings-Filter'!

ListItemWrapper subclass: #SettingTreeNode
	instanceVariableNames: 'parentNode contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingTreeNode methodsFor: 'comparing' stamp: 'alain.plantec 3/3/2009 22:46'!
<= other
	^ self asString <= other asString! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 20:56'!
asString
	^ self item value asString! !

!SettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/23/2009 10:11'!
browseDeclaration
	self item browseDeclaration! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 16:07'!
buildContents
	| ct |
	ct := (self childrenItems asArray sort: self model client itemSortBlock) asOrderedCollection
				collect: [:d | self model nodeClass with: d model: self model].
	ct
		do: [:c | 
			c parentNode: self.
			c buildContents].
	^ ct ! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 11:55'!
childrenItems
	^ (self model childrenOf: self item) 
! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 08:53'!
contents
	^ contents ifNil: [contents := self buildContents ]
	! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 22:07'!
description
	^ self item description! !

!SettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/30/2009 16:21'!
exploreItem
	self item explore! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 16:30'!
icon
	^ self item value ifNotNil: [:v | v icon ] ! !

!SettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/30/2009 16:20'!
inspectItem
	self item inspect! !

!SettingTreeNode methodsFor: 'testing' stamp: 'alain.plantec 3/17/2009 09:45'!
isEmpty
	^ self contents isEmpty! !

!SettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/30/2009 22:56'!
keyStroke: aCharacter from: aTreeMorph 
	aCharacter = $b
		ifTrue: [self menuBrowse. ^ true].
	aCharacter = $i
		ifTrue: [self inspectItem. ^ true].
	aCharacter = $I
		ifTrue: [self exploreItem. ^ true].
	^ false
! !

!SettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/30/2009 16:22'!
menu: menu shifted: b 
	menu
		add: 'Browse (b)' translated
		target: self
		selector: #browseDeclaration.
	menu
		add: 'Inspect (i)' translated
		target: self
		selector: #inspectItem.
	menu
		add: 'Explore (I)' translated
		target: self
		selector: #exploreItem.
! !

!SettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/23/2009 10:11'!
menuBrowse
	self browseDeclaration! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 22:14'!
package
	^ self item package! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 10:17'!
parentNode
	^ parentNode! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 08:53'!
parentNode: aNode
	parentNode := aNode
	! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 10:17'!
pathString
	^ String streamContents: [:s | 
		self parentNode
			ifNotNil: [:p | s nextPutAll: p pathString].
			s nextPut: $/.
			s nextPutAll: self item value name]
! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 10:01'!
rowMorphListFor: aContainer
	^ item value ifNotNil: [:v | v rowMorphListFor: aContainer]! !

!SettingTreeNode methodsFor: 'updating' stamp: 'alain.plantec 3/25/2009 22:39'!
updateAccordingTo: aFilter 
	self contents do: [ :n | n updateAccordingTo: aFilter ].
	self contents removeAllSuchThat: [ :n | n isEmpty and: [ (aFilter keepHandler: n item) not ] ]! !

SettingTreeNode subclass: #UnclassifiedSettingTreeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!UnclassifiedSettingTreeNode classSide methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/28/2009 11:58'!
model: aModel 
	| pragma |
	pragma := (Pragma allNamed: #unclassifiedSettingRoot in: self class) first.
	^ self
		with: (SettingHandler pragma: pragma receiver: pragma methodClass theNonMetaClass)
		model: aModel! !

!UnclassifiedSettingTreeNode classSide methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/23/2009 12:31'!
unclassifiedSettingRoot
	<unclassifiedSettingRoot>
	^ (SettingManager newNode: '** Unclassified **')
		description: 'All setting values with unkown parent'! !

!UnclassifiedSettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/28/2009 10:47'!
childrenItems
	^ self model unclassified! !

!UnclassifiedSettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 16:45'!
icon
	^ MenuIcons smallDebugIcon! !

!UnclassifiedSettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 10:24'!
package
	^ nil! !

!String class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:02'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForString! !

Morph subclass: #MorphTreeNodeMorph
	instanceVariableNames: 'indentLevel isExpanded complexContents firstChild container nextSibling icon rowMorph controls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Morphic'!

!MorphTreeNodeMorph methodsFor: 'drag and drop' stamp: 'alain.plantec 3/7/2009 09:29'!
acceptDroppingMorph: toDrop event: evt
	complexContents acceptDroppingObject: toDrop complexContents.
	toDrop delete.
	self highlightForDrop: false.! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/10/2009 23:21'!
addChildrenForList: hostList addingTo: morphList withExpandedItems: expandedItems

	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aNode delete].
	].
	firstChild := nil.
	complexContents hasContents ifFalse: [^self].
	firstChild := hostList 
		addMorphsTo: morphList
		from: complexContents contents 
		allowSorting: true
		withExpandedItems: expandedItems
		atLevel: indentLevel + 1.
	! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
balloonText

	^complexContents balloonText ifNil: [super balloonText]! !

!MorphTreeNodeMorph methodsFor: 'halos and balloon help' stamp: 'alain.plantec 3/7/2009 09:29'!
boundsForBalloon

	"some morphs have bounds that are way too big"
	container ifNil: [^super boundsForBalloon].
	^self boundsInWorld intersect: container boundsInWorld! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
canExpand

	^complexContents hasContents! !

!MorphTreeNodeMorph methodsFor: 'updating' stamp: 'alain.plantec 3/12/2009 09:48'!
changed
	"Need to invalidate the selection frame."
	container
		ifNil: [super changed] 
		ifNotNil: [self invalidRect: self selectionFrame]! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
children
	| children |
	children := OrderedCollection new.
	self childrenDo: [:each | children add: each].
	^children! !

!MorphTreeNodeMorph methodsFor: 'enumeration' stamp: 'alain.plantec 3/7/2009 09:29'!
childrenDo: aBlock

	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aBlock value: aNode].
	]! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/7/2009 09:29'!
complexContents

	^complexContents! !

!MorphTreeNodeMorph methodsFor: 'initialization' stamp: 'alain.plantec 3/17/2009 10:02'!
controlBounds
	| columns firstWidth controlBounds currControl currLeft currRight offset gap controlsCopy |
	controls ifEmpty: [^ #()].
	controlBounds := OrderedCollection new.
	offset := 0.
	controlsCopy := controls copy asOrderedCollection.
	container columns  isEmptyOrNil
		ifFalse: [ columns := container columns asOrderedCollection.
			gap := container leftGap.
			firstWidth := columns removeFirst.
			currControl := controlsCopy removeFirst.
			currLeft := currControl left. 
			currRight := currLeft + firstWidth - self spacerWidth -rowMorph cellInset.
			offset := offset + (currRight - currControl right ).
			controlBounds add: (currLeft @ currControl top corner: currRight @ currControl bottom).
			columns
				withIndexDo: [:width :idx | controlsCopy notEmpty
						ifTrue: [currLeft := currRight + container resizerWidth.
							currRight := currLeft + width - rowMorph cellInset.
							currControl := controlsCopy removeFirst.
							controlBounds add: (currLeft @ currControl top corner: currRight @ currControl bottom).
							offset := offset + (currRight - currControl right)]]].
	controlsCopy
		do: [:ctrl | 
			ctrl fullBounds.
			controlBounds add: (ctrl left + offset @ ctrl top corner: ctrl right + offset @ ctrl bottom)].
	^ controlBounds! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/7/2009 09:29'!
drawLineToggleToTextOn: aCanvas lineColor: lineColor hasToggle: hasToggle
	"If I am not the only item in my container, draw the line between:
		- my toggle (if any) or my left edge (if no toggle)
		- and my text left edge.
	Only draw now if no toggle."

	| myBounds myCenter hLineY hLineLeft myTheme|
	self isSoleItem ifTrue: [ ^self ].
	self hasToggle ifTrue: [^self].
	myBounds := self toggleBounds.
	myCenter := myBounds center.
	hLineY := myCenter y - 1.
	hLineLeft := myCenter x.
	"Draw line from toggle to text. Use optimised form since vertical."
	myTheme _ self theme.
	aCanvas
		frameRectangle: (hLineLeft @ hLineY corner: myBounds right + 3 @ (hLineY + 1))
		width: myTheme treeLineWidth
		colors: (myTheme treeLineColorsFrom: lineColor)
		dashes: myTheme treeLineDashes! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/9/2009 11:03'!
drawLinesOn: aCanvas lineColor: lineColor 
	| hasToggle |
	hasToggle := self hasToggle.
	"Draw line from toggle to text"
	self drawLineToggleToTextOn: aCanvas lineColor: lineColor hasToggle: hasToggle.

	"Draw the line from my toggle to the nextSibling's toggle"
	self nextSibling ifNotNil: [ self drawLinesToNextSiblingOn: aCanvas lineColor: lineColor hasToggle: hasToggle ].

	"If I have children and am expanded, draw a line to my first child"
	(self firstChild notNil and: [ self isExpanded ])
		ifTrue: [ self drawLinesToFirstChildOn: aCanvas lineColor: lineColor]! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/7/2009 09:29'!
drawLinesToFirstChildOn: aCanvas lineColor: lineColor 
	"Draw line from me to first child.
	Don't bother if the first child has a toggle.."

	| vLineX vLineTop vLineBottom childBounds childCenter myTheme|
	self firstChild hasToggle ifTrue: [^self].
	childBounds := self firstChild toggleBounds.
	childCenter := childBounds center.
	vLineX := childCenter x.
	vLineTop := bounds bottom.
	self firstChild hasToggle
		ifTrue: [vLineBottom := childCenter y - (childBounds height // 2) + 1]
		ifFalse: [vLineBottom := childCenter y - 2].
	myTheme _ self theme.
	aCanvas
		frameRectangle: (vLineX @ vLineTop corner: vLineX + 1 @ vLineBottom)
		width: myTheme treeLineWidth
		colors: (myTheme treeLineColorsFrom: lineColor)
		dashes: myTheme treeLineDashes! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/9/2009 10:08'!
drawLinesToNextSiblingOn: aCanvas lineColor: lineColor hasToggle: hasToggle
	"Draw line from me to next sibling"
	
	| myBounds nextSibBounds vLineX myCenter vLineTop vLineBottom myTheme|
	myBounds := self toggleBounds.
	nextSibBounds := self nextSibling toggleBounds.
	myCenter := myBounds center.
	vLineX := myCenter x.
	vLineTop := myCenter y + 1.
	vLineBottom := nextSibBounds center y - 1.
	"Draw line from me to next sibling"
	myTheme _ self theme.
	aCanvas
		frameRectangle: (vLineX @ vLineTop corner: vLineX + 1 @ vLineBottom)
		width: myTheme treeLineWidth
		colors: (myTheme treeLineColorsFrom: lineColor)
		dashes: myTheme treeLineDashes! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/8/2009 13:49'!
drawMouseDownHighlightOn: aCanvas
	"Draw with a dotted border."
	
	|frame|
	self highlightedForMouseDown ifTrue: [
		container ifNil: [^super drawMouseDownHighlightOn: aCanvas].
		frame := self selectionFrame.
		aCanvas 
			frameRectangle: frame
			width: 1
			colors: {container mouseDownHighlightColor. Color transparent}
			 dashes: #(1 1)]! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/11/2009 08:03'!
drawOn: aCanvas 
	| tRect sRect | 
	aCanvas 
			frameRectangle: self selectionFrame
			width: 1
			colors: {Color veryLightGray. Color transparent}
			 dashes: #(1 2).
	tRect := self toggleRectangle.
	self drawToggleOn: aCanvas in: tRect.
	sRect := bounds withLeft: tRect right + container gapBetweenToggleAndIcon.
	icon notNil ifTrue: [aCanvas translucentImage: icon at: sRect left @ (self top + (self height - icon height // 2))].
! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/7/2009 09:29'!
drawToggleOn: aCanvas in: aRectangle

	| aForm centeringOffset |
	complexContents hasContents ifFalse: [^self].
	aForm := isExpanded 
		ifTrue: [container expandedForm]
		ifFalse: [container notExpandedForm].
	centeringOffset := ((aRectangle height - aForm extent y) / 2.0) truncated.
	^aCanvas 
		translucentImage: aForm 
		at: (aRectangle topLeft translateBy: 0 @ centeringOffset).
! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
firstChild

	^firstChild! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
hasIcon
	"Answer whether the receiver has an icon."
	^ icon notNil! !

!MorphTreeNodeMorph methodsFor: 'private' stamp: 'alain.plantec 3/7/2009 09:29'!
hasToggle
	^ complexContents hasContents! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/7/2009 09:29'!
highlight

	complexContents highlightingColor ifNotNil: [self color: complexContents highlightingColor].
	self changed.
	
! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
icon
	"answer the receiver's icon"
	^ icon! !

!MorphTreeNodeMorph methodsFor: 'mouse events' stamp: 'alain.plantec 3/7/2009 09:29'!
inToggleArea: aPoint

	^self toggleRectangle containsPoint: aPoint! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/10/2009 13:16'!
indentGap
	^ container indentGap * indentLevel! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
indentLevel

	^indentLevel! !

!MorphTreeNodeMorph methodsFor: 'initialization' stamp: 'alain.plantec 3/16/2009 13:40'!
initWithContents: anObject prior: priorMorph forList: hostList indentLevel: newLevel 
	| spacer rowControls |
	self initialize.
	container := hostList.
	complexContents := anObject.
	isExpanded := false.
	nextSibling := firstChild := nil.
	priorMorph ifNotNil: [priorMorph nextSibling: self].
	indentLevel := newLevel.
	icon := anObject icon.
	self addMorphBack: (spacer := (self transparentSpacerOfSize: (1 @ 1))).
	spacer width: self spacerWidth.
	controls := ((complexContents rowMorphListFor: container) ifNil: [#()]) asOrderedCollection.
	rowControls := OrderedCollection new.
	controls do: [:ctrl | rowControls add: ctrl] separatedBy: [rowControls add: ((self transparentSpacerOfSize: container resizerWidth @1) )].
	rowMorph := UITheme current newRowIn: World for: rowControls.
	rowMorph fullBounds.
	rowMorph cellInset: 2.
	self addMorphBack: rowMorph.
	self updateColumns.
	! !

!MorphTreeNodeMorph methodsFor: 'initialization' stamp: 'alain.plantec 3/10/2009 21:54'!
initialize
	"initialize the state of the receiver"
	super initialize.
	self layoutPolicy: TableLayout new.
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.
	self listDirection: #leftToRight.
	self cellPositioning: #topLeft.
	self color: Color transparent.
! !

!MorphTreeNodeMorph methodsFor: 'updating' stamp: 'alain.plantec 3/12/2009 11:43'!
innerWidgetChanged
	container ifNotNil: [container innerWidgetChanged]! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
isExpanded

	^isExpanded! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
isExpanded: aBoolean

	isExpanded := aBoolean! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
isFirstItem
	^owner submorphs first == self! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
isSoleItem
	^self isFirstItem and: [ owner submorphs size = 1 ]! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
lastChild
	"Answer the last child."

	|c|
	c _ self firstChild ifNil: [^nil].
	[c nextSibling isNil] whileFalse: [c _ c nextSibling].
	^c! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/9/2009 08:22'!
minHeight
	"Answer the minimum height of the receiver."
	
	| iconHeight |
	iconHeight := self hasIcon
				ifTrue: [self icon height + 2]
				ifFalse: [0].
	^(rowMorph height max: iconHeight) max: super minHeight! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/9/2009 08:22'!
minWidth
	"Fixed to work such that guessed width is unnecessary in
	#adjustSubmorphPositions."

	| iconWidth |
	iconWidth := self hasIcon
				ifTrue: [self icon width + 2]
				ifFalse: [0].
	^(13 * indentLevel + 15 + rowMorph minWidth + iconWidth) max: super minWidth! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
nextSibling

	^nextSibling! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
nextSibling: anotherMorph

	nextSibling := anotherMorph! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
openItemPath: anArray
	"Open a path based on wrapper item equivalence. Generally more specific
	than #openPath: (string based)."
	
	| found |
	anArray isEmpty
		ifTrue: [^ container setSelectedMorph: nil].
	found := nil.
	self
		withSiblingsDo: [:each | found
				ifNil: [(each complexContents withoutListWrapper == anArray first
							or: [anArray first isNil])
						ifTrue: [found := each]]].
	found
		ifNotNil: [found isExpanded
				ifFalse: [found toggleExpandedState.
					container adjustSubmorphPositions].
			found changed.
			anArray size = 1
				ifTrue: [^ container setSelectedMorph: found].
			^ found firstChild
				ifNil: [container setSelectedMorph: nil]
				ifNotNil: [found firstChild openItemPath: anArray allButFirst]].
	^container setSelectedMorph: nil! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/7/2009 09:29'!
openPath: anArray 
	| found |
	anArray isEmpty
		ifTrue: [^ container setSelectedMorph: nil].
	found := nil.
	self
		withSiblingsDo: [:each | found
				ifNil: [(each complexContents asString = anArray first
							or: [anArray first isNil])
						ifTrue: [found := each]]].
	found
		ifNil: ["try again with no case sensitivity"
			self
				withSiblingsDo: [:each | found
						ifNil: [(each complexContents asString sameAs: anArray first)
								ifTrue: [found := each]]]].
	found
		ifNotNil: [found isExpanded
				ifFalse: [found toggleExpandedState.
					container adjustSubmorphPositions].
			found changed.
			anArray size = 1
				ifTrue: [^ container setSelectedMorph: found].
			^ found firstChild
				ifNil: [container setSelectedMorph: nil]
				ifNotNil: [found firstChild openPath: anArray allButFirst]].
	^ container setSelectedMorph: nil! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
outerBounds
	"Return the 'outer' bounds of the receiver, e.g., the bounds that need to be invalidated when the receiver changes."
	
	|box|
	box _ super outerBounds.
	container ifNil: [^box].
	^box left: (box left min: self selectionFrame left)! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/7/2009 09:29'!
recursiveAddTo: aCollection

	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aNode recursiveAddTo: aCollection].
	].
	aCollection add: self
	! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/7/2009 09:29'!
recursiveDelete

	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aNode recursiveDelete].
	].
	self delete
	! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
selectionFrame
	"Answer the selection frame rectangle."

	|frame|
	frame := self bounds: self bounds in: container.
	frame := self
		bounds: ((frame left: container innerBounds left) right: container innerBounds right)
		from: container.
	^frame! !

!MorphTreeNodeMorph methodsFor: 'initialization' stamp: 'alain.plantec 3/10/2009 22:37'!
spacerWidth
	| sRect  spacer |
	spacer := self firstSubmorph.
	sRect := bounds withLeft: self toggleRectangle right + container gapBetweenToggleAndIcon.
	sRect := sRect withLeft: sRect left + container iconReservedExtent x + container gapAfterIcon.
	^ sRect left - bounds left.
! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
theme
	"Answer the ui theme that provides controls.
	Done directly here to avoid performance hit of
	looking up in window."

	^UITheme current! !

!MorphTreeNodeMorph methodsFor: 'private' stamp: 'alain.plantec 3/7/2009 09:29'!
toggleBounds
	^self toggleRectangle! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/7/2009 09:29'!
toggleExpandedState

 	| newChildren toDelete c |

	isExpanded := isExpanded not.
	toDelete := OrderedCollection new.
	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aNode recursiveAddTo: toDelete].
	].
	container noteRemovalOfAll: toDelete.
	(isExpanded and: [complexContents hasContents]) ifFalse: [
		^self changed
	].
	(c := complexContents contents) isEmpty ifTrue: [^self changed].
	newChildren := container 
		addSubmorphsAfter: self 
		fromCollection: c 
		allowSorting: true.
	firstChild := newChildren first.
! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 17:54'!
toggleImageMorph
	^ ImageMorph new
		image: (isExpanded
				ifTrue: [container expandedForm]
				ifFalse: [container notExpandedForm]) ! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/10/2009 13:17'!
toggleRectangle
	^(bounds left + self indentGap) @ bounds top extent: container toggleImageWidth @ bounds height! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/7/2009 09:29'!
unhighlight

	complexContents highlightingColor ifNotNil: [self color: Color black].
	self changed.
	
	
! !

!MorphTreeNodeMorph methodsFor: 'initialization' stamp: 'alain.plantec 3/10/2009 21:16'!
updateColumns
	|  columns spacer |
	container columns  isEmptyOrNil ifTrue: [^ self].
	columns := container columns asOrderedCollection.
	spacer := self firstSubmorph.
	spacer width: self spacerWidth.
	self controlBounds withIndexDo: [:bnd :idx | | ctrl |
		ctrl := controls at: idx.
		ctrl width: bnd width].
	rowMorph fullBounds! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
userString
	"Add leading tabs to my userString"
	^ (String new: indentLevel withAll: Character tab), super userString
! !

!MorphTreeNodeMorph methodsFor: 'private' stamp: 'alain.plantec 3/7/2009 09:29'!
withSiblingsDo: aBlock

	| node |
	node := self.
	[node isNil] whileFalse: [
		aBlock value: node.
		node := node nextSibling
	].! !

!MorphTreeNodeMorph methodsFor: 'converting' stamp: 'alain.plantec 3/7/2009 09:29'!
withoutListWrapper

	^complexContents withoutListWrapper! !

AbstractResizerMorph subclass: #MorphTreeResizerMorph
	instanceVariableNames: 'traceMorph oldColor lineNumber treeList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Morphic'!

!MorphTreeResizerMorph class methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/12/2009 21:40'!
fastSplitterResize
	^ Preferences fastDragWindowForMorphic! !

!MorphTreeResizerMorph class methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 13:18'!
treeList: aTreeList lineNumber: anInteger
	^ self new treeList: aTreeList lineNumber: anInteger! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 12:56'!
adoptPaneColor: paneColor 
	"Change our color too."
	super adoptPaneColor: paneColor.
	self fillStyle: self normalFillStyle! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 23:00'!
getOldColor
	^ oldColor ifNil: [Color transparent]! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 13:08'!
mouseDown: anEvent 
	"A mouse button has been pressed.
	Update the color for feedback and store the mouse
	position and relative offset to the receiver."
	| cp |
	(self bounds containsPoint: anEvent cursorPoint)
		ifTrue: [oldColor := self color.
			self setGrabbedColor].
	cp := anEvent cursorPoint.
	lastMouse := {cp. cp - self position}! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 07:31'!
mouseMove: anEvent 
	anEvent hand temporaryCursor
		ifNil: [^ self].
	self class fastSplitterResize
		ifTrue: [traceMorph
				ifNil: [traceMorph := Morph newBounds: self bounds.
					traceMorph borderColor: Color lightGray.
					traceMorph borderWidth: 1.
					self owner addMorph: traceMorph].
			traceMorph position: (anEvent cursorPoint x - lastMouse second x) @ traceMorph position y]
		ifFalse: [self updateFromEvent: anEvent]! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 13:04'!
mouseUp: anEvent
	"Change the cursor back to normal if necessary and change the color back to normal."
	
	(self bounds containsPoint: anEvent cursorPoint)
		ifFalse: [anEvent hand showTemporaryCursor: nil].
	self class fastSplitterResize
		ifTrue: [self updateFromEvent: anEvent].
	traceMorph ifNotNil: [traceMorph delete. traceMorph := nil].
	self adoptPaneColor: self paneColor.
	self triggerEvent: #mouseUp! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 12:55'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	^ self theme splitterNormalFillStyleFor: self! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 14:09'!
normalizedX: x

	^ x! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 14:09'!
normalizedY: y 
	^y! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 12:55'!
pressedFillStyle
	"Return the pressed fillStyle of the receiver."
	^ self theme splitterPressedFillStyleFor: self! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 12:53'!
resizeCursor
	^ Cursor resizeForEdge: #left! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 13:09'!
setGrabbedColor
	"Set the color of the receiver when it is grabbed."
	
	self fillStyle: self pressedFillStyle! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 12:55'!
shouldDraw
	^ true! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 07:45'!
splitsTopAndBottom
	^ false! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 13:19'!
treeList: aTreeList lineNumber: anInteger
	treeList := aTreeList.
	lineNumber := anInteger! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 08:14'!
updateFromEvent: anEvent 
	"Update the splitter and attached morph positions from
	the mouse event.
	Take into account the mouse down offset."
	| pNew previousX newWidth minX newLeft |
	pNew := anEvent cursorPoint - lastMouse second.
	minX := lineNumber = 1 
		ifTrue: [treeList minResizerX] 
		ifFalse: [(treeList columnResizers at: lineNumber - 1) right].
	newLeft := (minX max: pNew x).
	self left: newLeft.
	previousX := lineNumber = 1 
		ifTrue: [treeList scroller left] 
		ifFalse: [(treeList columnResizers at: lineNumber - 1) left].
	newWidth := treeList leftGap max: (self left - previousX) .
	treeList columns at: lineNumber put: newWidth.
	treeList updateColumns.

! !

Announcement subclass: #PragmaCollectorAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Pragma'!

PragmaCollectorAnnouncement subclass: #PragmaCollectorReinitialized
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Pragma'!

PragmaCollectorAnnouncement subclass: #PragmaHandlerAnnouncement
	instanceVariableNames: 'handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Pragma'!

!PragmaHandlerAnnouncement classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/27/2009 23:16'!
handler: aPragmaHandler
	^ self new handler: aPragmaHandler ! !

!PragmaHandlerAnnouncement methodsFor: 'accessing' stamp: 'alain.plantec 3/21/2009 14:29'!
handler
	^ handler! !

!PragmaHandlerAnnouncement methodsFor: 'accessing' stamp: 'alain.plantec 3/21/2009 14:30'!
handler: aPragmaHandler
	handler := aPragmaHandler! !

!PragmaHandlerAnnouncement methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 09:08'!
message
	^ ''! !

PragmaHandlerAnnouncement subclass: #PragmaRegistered
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Pragma'!

PragmaHandlerAnnouncement subclass: #PragmaUnregistered
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Pragma'!

PragmaHandlerAnnouncement subclass: #PragmaUpdated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Pragma'!

PragmaHandlerAnnouncement subclass: #PragmaWithError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Pragma'!

!PragmaWithError methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 15:27'!
message
	^ 'Setting method with error: ', handler methodClass name, '>>', handler selector asString.! !

DialogWindow subclass: #SettingPackageChooser
	instanceVariableNames: 'list listIndex listSelections listMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:06'!
chooseFrom: aList 
	list := aList.
	listSelections := nil.
	self updateList! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:14'!
chosen
	| chosen |
	chosen := OrderedCollection new.
	1
		to: self list size
		do: [:i | (self listSelections at: i)
				ifTrue: [chosen
						add: (self list at: i)]].
	^ chosen! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:18'!
chosen: aList 
	listSelections := nil.
	aList
		do: [:i | (self list
						indexOf: i
						ifAbsent: [])
				ifNotNil: [:idx | self listSelections at: idx put: true]].
	self updateList.! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/18/2009 07:11'!
deselectAll
	listSelections := nil.
	self updateList
	
	! !

!SettingPackageChooser methodsFor: 'open/close' stamp: 'alain.plantec 3/17/2009 22:12'!
initialExtent
	"Answer the initial extent for the receiver.
	Adjust the text if the text	would be wider than 1/4
	the display width."
	^ (super initialExtent x max: 250)
		@ 500! !

!SettingPackageChooser methodsFor: 'initialization' stamp: 'alain.plantec 3/17/2009 17:43'!
initialize
	super initialize.
	self title: 'Choose'.
! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:01'!
list
	^ list
		ifNil: [list := SortedCollection new]! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:01'!
listIndex
	^ listIndex ifNil: [listIndex := 0]					
! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:02'!
listIndex: anInteger
	listIndex := anInteger.
	self changed: #listIndex
! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:33'!
listMorph
	^ listMorph
		ifNil: [listMorph := PluggableListMorphOfMany
						on: self
						list: #list
						primarySelection: #listIndex
						changePrimarySelection: #toggleListIndex:
						listSelection: #listSelectionAt:
						changeListSelection: #listSelectionAt:put:
						menu: nil]! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:07'!
listSelectionAt: index
	^ self listSelections at: index! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:33'!
listSelectionAt: index put: value
	^ listSelections at: index put: value! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:04'!
listSelections
	listSelections ifNil: [
		list ifNotNil: [
			listSelections := Array new: list size withAll: false]].
	^ listSelections! !

!SettingPackageChooser methodsFor: 'open/close' stamp: 'alain.plantec 3/18/2009 07:09'!
newButtons
	^ {self
		newButtonFor: self
		getState: nil
		action: #deselectAll
		arguments: nil
		getEnabled: nil
		label: 'Deselect all' translated
		help: 'Deselect all packages' translated}, super newButtons! !

!SettingPackageChooser methodsFor: 'open/close' stamp: 'alain.plantec 3/17/2009 22:11'!
newContentMorph
	| col |
	col := (self newRow: {self listMorph vResizing: #spaceFill; hResizing: #spaceFill})
				vResizing: #spaceFill.
	^ col vResizing: #spaceFill! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:08'!
toggleListIndex: newListIndex

	listIndex ~= 0 ifTrue: [listSelections at: listIndex put: false].
	newListIndex ~= 0 ifTrue: [listSelections at: newListIndex put: true].
	listIndex := newListIndex.
	self changed: #listIndex.
	self contentsChanged! !

!SettingPackageChooser methodsFor: 'updating' stamp: 'alain.plantec 3/17/2009 22:06'!
updateList
	self changed: #list.
! !

!Color class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 14:48'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForColor! !

!Association methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/24/2009 23:20'!
settingFixedDomainValueNodeFrom: aSettingNode 
	^ aSettingNode fixedDomainValueNodeForAssociation: self! !

!LogicalFont methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/19/2009 10:02'!
settingStoreOn: aStream 
	aStream nextPut: $(.
	aStream nextPutAll: self class name.
	aStream nextPut: Character space.
	aStream nextPutAll: 'familyName: '.
	self familyName settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'fallbackFamilyNames: '.
	self fallbackFamilyNames settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'pointSize: '.
	self pointSize settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'stretchValue: '.
	self stretchValue settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'weightValue: '.
	self weightValue settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'slantValue: '.
	self slantValue settingStoreOn: aStream.
	aStream nextPut: $)! !

!AbstractFont class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 14:49'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForFont! !

!Number class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:09'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForNumber! !

DropListMorph subclass: #EditableDropListMorph
	instanceVariableNames: 'addToListSel content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Morphic'!

!EditableDropListMorph class methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 16:13'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel useIndex: useIndex addToList: addToListSel 
	^ self
		on: anObject
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel
		useIndex: useIndex
		addToList: addToListSel 
		class: nil
		getEnabled: nil! !

!EditableDropListMorph class methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 16:12'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel useIndex: useIndex addToList: addToListSel class: aClass getEnabled: getEnabledSel 
	^ (super
		on: anObject
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel
		useIndex: useIndex) convertTo: aClass; 
		 getEnabledSelector: getEnabledSel;
		 addToList: addToListSel;
		 yourself! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 13:03'!
addToList: aSelector
	addToListSel := aSelector! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 15:26'!
content
	^ content
! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 15:51'!
content: aString
	content := aString.
	self model perform: addToListSel with: aString.
	self listSelectionIndex: (self list indexOf: aString).
	self updateList.
	! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 16:30'!
convertTo: aClass 
	self contentMorph convertTo: aClass ! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/16/2009 10:36'!
initialize
	super initialize.
	self height: self contentMorph minHeight! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 18:21'!
listHeight
	"Answer the height for the list."
	^(self listMorph listMorph height + 12) min: 200! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/16/2009 10:37'!
newContentMorph
	"Answer a new content morph"
	^ (UITheme current
		newTextEntryIn: World
		for: self
		get: #content
		set: #content:
		class: String
		getEnabled: nil
		help: nil) 
		 hResizing: #spaceFill;
		 autoAccept: false! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 15:44'!
updateContentColor: paneColor
	"Change the content text color."
	
	self enabled
		ifTrue: [self contentMorph setTextColor: Color black]
		ifFalse: [self contentMorph setTextColor: paneColor duller]! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 15:36'!
updateContents
	"Update the contents."

	|sel|
	self contentMorph
		setText: (self listSelectionIndex > 0
			ifTrue: [sel := self list at: self listSelectionIndex.
					sel isText
						ifTrue: [sel]
						ifFalse: [sel asString]]
			ifFalse: [' ']) "needs something to keep font"! !

!Boolean class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 14:48'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForBoolean! !

SimpleHierarchicalListMorph subclass: #MorphTreeMorph
	instanceVariableNames: 'enabled columnResizers lightFrame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Morphic'!

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/19/2009 16:51'!
addColumnResizers
	| offset |
	offset := 0.
	columnResizers := self columnResizerFrames
				withIndexCollect: [:frm :idx | (MorphTreeResizerMorph treeList: self lineNumber: idx) bounds: frm].
	self addAllMorphs: columnResizers.
	columnResizers
		do: [:cl | cl comeToFront]! !

!MorphTreeMorph methodsFor: 'private' stamp: 'alain.plantec 3/11/2009 08:24'!
addSubmorphsAfter: parentMorph fromCollection: aCollection allowSorting: sortBoolean
	"Update the extent on each morph."
	
	|answer|
	answer := super addSubmorphsAfter: parentMorph fromCollection: aCollection allowSorting: sortBoolean.
	self scroller submorphsDo: [:i |
		i
			extent: i minWidth @ i minHeight].
	self updateColumnResizers.
	^answer! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 08:21'!
columnResizerFrames
	| offset |
	offset := 0.
	^ columns
		ifNil: [#()]
		ifNotNil: [columns
				collect: [:col | 
					offset = 0 
						ifTrue: [offset := offset + (self minResizerOffset max: col)]
						ifFalse: [offset := offset + col].
					scroller left + offset @ self top corner: scroller left + offset + self resizerWidth @ self bottom]]! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 12:35'!
columnResizers
	^ columnResizers ! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 07:23'!
columns: aCollection 
	super columns: aCollection asOrderedCollection.
	columns := columns collect: [:c | c + self leftGap].
	self addColumnResizers! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 23:21'!
extent: aPoint
	super extent: aPoint.
	self updateColumns.
! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 13:32'!
gapAfterIcon
	^ 5! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 13:24'!
gapBetweenToggleAndIcon
	^ 4! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 13:20'!
iconReservedExtent
	^ 16 @ 16! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 13:15'!
indentGap
	^ 13! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/19/2009 16:52'!
indentingItemClass
	
	^MorphTreeNodeMorph! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/12/2009 11:42'!
innerWidgetChanged
	self setScrollDeltas.
	self adjustSubmorphPositions! !

!MorphTreeMorph methodsFor: 'private' stamp: 'alain.plantec 3/9/2009 13:41'!
insertNewMorphs: morphList 
	"Update the extent on each morph."
	morphList
		do: [:m | m extent: m minWidth @ m minHeight].
	^ super insertNewMorphs: morphList! !

!MorphTreeMorph methodsFor: 'private' stamp: 'alain.plantec 3/9/2009 10:33'!
layoutBounds: aRectangle
	"Set the bounds for laying out children of the receiver.
	Update the scroller and scrollbars now since bounds set directly
	(not via #extent:)."
	
	super layoutBounds: aRectangle.
	self
		resizeScroller;
		setScrollDeltas! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 11:06'!
leftGap
	^self toggleImageWidth + self gapBetweenToggleAndIcon + self iconReservedExtent x + self gapAfterIcon.
! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 08:19'!
minResizerOffset
	| minX |
	minX := self leftGap.
	scroller submorphsDo: [:sm | minX := minX max: (sm spacerWidth)].
	^ minX! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 08:34'!
minResizerX
	^ scroller left + self minResizerOffset! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 22:24'!
resizerWidth
	^ 5! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 13:13'!
toggleImageHeight
	| expandedImage notExpandedImage |
	expandedImage := ImageMorph new image: self expandedForm.
	notExpandedImage := ImageMorph new image: self notExpandedForm.
	^ expandedImage height max: notExpandedImage height.! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 13:14'!
toggleImageWidth
	| expandedImage notExpandedImage |
	expandedImage := ImageMorph new image: self expandedForm.
	notExpandedImage := ImageMorph new image: self notExpandedForm.
	^ expandedImage width max: notExpandedImage width.! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/16/2009 16:15'!
update: aSymbol 
	super update: aSymbol.
! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 08:26'!
updateColumnResizers
	columnResizers
		ifNotNil: [self columnResizerFrames
				doWithIndex: [:frm :idx | (columnResizers at: idx)
						bounds: frm]].
	scroller changed! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 12:22'!
updateColumns
	self scroller
		submorphsDo: [:i | i updateColumns].
	self updateColumnResizers
! !

!Object methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/24/2009 23:21'!
settingFixedDomainValueNodeFrom: aSettingNode 
	^ aSettingNode fixedDomainValueNodeForObject: self! !

!Object methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/19/2009 09:50'!
settingStoreOn: aStream
	^ self storeOn: aStream! !

Object subclass: #PragmaCollector
	instanceVariableNames: 'announcer collected client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Pragma'!

!PragmaCollector commentStamp: 'alain.plantec 3/30/2009 13:25' prior: 0!
A PragmaCollector is able to store all pragmas according to a rule implemented by the #keepPragma method.
The contents is made of a collection of PragmaHandler instances.
A PragmaCollector makes use of SystemChangeNotifier event notifications in order to maintain its contents:
when a method is added, removed or updated, if it contains a pragma then the collector contents 
is eventually updated. A PragmaCollector makes use of an annoucer in order to notify all registered objects when a pragma handler is added, removed or updated.
A PragmaCollector is always associated with a client object. The client must implement #handlerFromPragma: wich
is used in order to get and store a pragma handler from a pragma.


Instance Variables
	announcer:		<Announcer>
	collected:		<Collection of PragmaHandler>
	client:				<Object>

!

!PragmaCollector class methodsFor: 'instance creation' stamp: 'alain.plantec 3/30/2009 11:22'!
client: aClient
	^ self new client: aClient! !

!PragmaCollector methodsFor: 'updating' stamp: 'alain.plantec 3/21/2009 14:54'!
addHandler: aPragmaHandler
	self collected add: aPragmaHandler.
	self announce: (PragmaRegistered new handler: aPragmaHandler)! !

!PragmaCollector methodsFor: 'updating' stamp: 'alain.plantec 3/30/2009 11:22'!
addHandlerFromPragma: aPragma
	(self client handlerFromPragma: aPragma) 
		ifNotNil: [:handler | self addHandler: handler]
! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/28/2009 11:34'!
addedEventOccurs: anEvent 
	Pragma
		withPragmasIn: anEvent itemClass
		do: [:pragma | pragma selector = anEvent itemSelector
				ifTrue: [self addHandlerFromPragma: pragma]] ! !

!PragmaCollector methodsFor: 'accessing' stamp: 'alain.plantec 3/28/2009 11:51'!
allPragmas
	^ (Array
		streamContents: [:stream | SystemNavigation default
				allBehaviorsDo: [:behavior | Pragma
						withPragmasIn: behavior
						do: [:pragma | stream nextPut: pragma]]]) asOrderedCollection ! !

!PragmaCollector methodsFor: 'subscription' stamp: 'alain.plantec 3/26/2009 14:31'!
announce: anAnnouncement
	self announcer ifNotNil: [announcer announce: anAnnouncement]! !

!PragmaCollector methodsFor: 'accessing' stamp: 'alain.plantec 3/21/2009 09:49'!
announcer
	^ announcer! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/27/2009 22:23'!
classRemovedEventOccurs: anEvent 
	anEvent itemClass theNonMetaClass = self class
		ifTrue: [^ self noMoreNotifications].
	(self handlersOfClass: anEvent itemClass class)
		do: [:handler | self removeHandler: handler] ! !

!PragmaCollector methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 11:20'!
client
	^ client ! !

!PragmaCollector methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 11:21'!
client: aClient
	client := aClient! !

!PragmaCollector methodsFor: 'enumerating' stamp: 'alain.plantec 3/21/2009 10:10'!
collect: aBlock
	^ self collected collect: aBlock
	! !

!PragmaCollector methodsFor: 'accessing' stamp: 'alain.plantec 3/21/2009 10:04'!
collected
	^ collected ifNil: [collected := OrderedCollection new]! !

!PragmaCollector methodsFor: 'accessing' stamp: 'alain.plantec 3/22/2009 11:04'!
collectedPragmas
	^ self collect: [:handler | handler pragma]! !

!PragmaCollector methodsFor: 'enumerating' stamp: 'alain.plantec 3/21/2009 10:11'!
detect: aBlock
	^ self collected detect: aBlock ifNone:[]
	! !

!PragmaCollector methodsFor: 'enumerating' stamp: 'alain.plantec 3/21/2009 10:11'!
do: aBlock
	self collected do: aBlock
	! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/30/2009 11:21'!
event: anEvent 
	"Hook for SystemChangeNotifier: 
	automatically updates the system settings when a
	method is added, removed or updated or when a
	class is removed
	"
	client class isObsolete
		ifFalse: [(anEvent itemKind = SystemChangeNotifier classKind
					and: [anEvent isRemoved])
				ifTrue: [^ self classRemovedEventOccurs: anEvent].
			anEvent itemKind = SystemChangeNotifier methodKind
				ifTrue: [anEvent isRemoved
						ifTrue: [^ self removedEventOccurs: anEvent]. 
					anEvent isAdded
						ifTrue: [^ self addedEventOccurs: anEvent].
					anEvent isModified
						ifTrue: [^ self modifiedEventOccurs: anEvent]]]! !

!PragmaCollector methodsFor: 'querying' stamp: 'alain.plantec 3/27/2009 17:30'!
handlerOf: aSelector inClass: aClass 
	"return the handler corresponding to a pragma method which selector is aSelector in class aClass"
	^ (self detect: [:handler | handler methodClass = aClass and: [handler selector = aSelector]])
	! !

!PragmaCollector methodsFor: 'querying' stamp: 'alain.plantec 3/27/2009 17:30'!
handlersOfClass: aClass 
	"return all handlers of class aClass"
	^ self	select: [:handler | handler methodClass = aClass ]! !

!PragmaCollector methodsFor: 'testing' stamp: 'alain.plantec 3/22/2009 10:17'!
ifNotEmpty: aBlock
	self collected ifNotEmpty: aBlock! !

!PragmaCollector methodsFor: 'initializing' stamp: 'alain.plantec 3/22/2009 10:56'!
initialize
	super initialize.
	announcer := Announcer new.
	self installSystemNotifications! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/22/2009 10:56'!
installSystemNotifications
	SystemChangeNotifier uniqueInstance 
		notify: self
		ofAllSystemChangesUsing: #event:! !

!PragmaCollector methodsFor: 'testing' stamp: 'alain.plantec 3/22/2009 10:17'!
isEmpty
	^ self collected isEmpty! !

!PragmaCollector methodsFor: 'testing' stamp: 'alain.plantec 3/22/2009 10:17'!
isNotEmpty
	^ self collected isNotEmpty! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/28/2009 11:41'!
modifiedEventOccurs: anEvent 
	"
	try to update an handler:
	1 - I already have one for aSelector and aClass, then
	do nothing, one have to reset defaults
	2 - I have one but changed method has no more
	acceptable pragma in it, but let handler alive (it can
	have listeners).
	3 - I do not have one but method has an acceptable
	pragma in it, then I try to add a new handler
	"
	Pragma
		withPragmasIn: anEvent itemClass
		do: [:pragma | pragma selector = anEvent itemSelector
				ifTrue: [(self 
								detect: [:handler | handler selector = pragma selector
										and: [handler methodClass = anEvent itemClass]])
						ifNotNil: [:handler | ^ self updateHandler: handler].
					^ self addHandlerFromPragma: pragma]]! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/26/2009 14:33'!
noMoreAnnounceWhile: aBlock 
	| oldAnnouncer |
	[oldAnnouncer := announcer.
	announcer := nil.
	aBlock value]
		ensure: [announcer := oldAnnouncer]! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/22/2009 10:08'!
noMoreNotifications
		SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self
! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/22/2009 10:56'!
noMoreNotificationsWhile: aBlock 
	self noMoreNotifications.
	[ aBlock value ] ensure: [ self installSystemNotifications ]! !

!PragmaCollector methodsFor: 'enumerating' stamp: 'alain.plantec 3/21/2009 10:11'!
noneSatisfy: aBlock
	^ self collected noneSatisfy: aBlock! !

!PragmaCollector methodsFor: 'enumerating' stamp: 'alain.plantec 3/21/2009 10:11'!
reject: aBlock
	^ self collected reject: aBlock ! !

!PragmaCollector methodsFor: 'dependents access' stamp: 'alain.plantec 3/30/2009 11:21'!
release
	self noMoreNotifications.
	announcer := nil.
	client := nil.
	self collected do: [:handler | handler release].
	collected := nil.
	super release.! !

!PragmaCollector methodsFor: 'updating' stamp: 'alain.plantec 3/28/2009 12:54'!
removeHandler: aPragmaHandler 
	self removeHandlerSilently: aPragmaHandler.
	self announce: (PragmaUnregistered new handler: aPragmaHandler)! !

!PragmaCollector methodsFor: 'updating' stamp: 'alain.plantec 3/30/2009 09:40'!
removeHandlerSilently: aPragmaHandler.
	aPragmaHandler release. 
	self collected remove: aPragmaHandler.
! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/27/2009 17:29'!
removedEventOccurs: anEvent 
	(self
				detect: [:handler | handler selector = anEvent itemSelector
						and: [handler methodClass = anEvent itemClass ]])
		ifNotNil: [:found | self removeHandler: found]! !

!PragmaCollector methodsFor: 'initializing' stamp: 'alain.plantec 3/28/2009 12:48'!
reset
	"reinitialize current system settings"
	self
		noMoreAnnounceWhile: [self collected copy
				do: [:handler | self removeHandler: handler].
			self allPragmas
				do: [:pragma | self addHandlerFromPragma: pragma]].
	self announce: PragmaCollectorReinitialized! !

!PragmaCollector methodsFor: 'enumerating' stamp: 'alain.plantec 3/21/2009 10:11'!
select: aBlock
	^ self collected select: aBlock
	! !

!PragmaCollector methodsFor: 'subscription' stamp: 'alain.plantec 3/21/2009 15:40'!
subscribe: anAnnouncement send: aSelector to: anObject
	self announcer subscribe: anAnnouncement send: aSelector to: anObject

! !

!PragmaCollector methodsFor: 'subscription' stamp: 'alain.plantec 3/22/2009 10:57'!
unsubscribe: anObject
	self announcer unsubscribe: anObject

! !

!PragmaCollector methodsFor: 'updating' stamp: 'alain.plantec 3/21/2009 15:52'!
updateHandler: aPragmaHandler 
	self announcer announce: (PragmaUpdated new handler: aPragmaHandler)! !

!PragmaCollector methodsFor: 'subscription' stamp: 'alain.plantec 3/26/2009 14:38'!
whenChangedSend: aSelector to: anObject
	self subscribe: PragmaHandlerAnnouncement send: aSelector to: anObject
! !

Object subclass: #PragmaHandler
	instanceVariableNames: 'pragma'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Pragma'!

!PragmaHandler commentStamp: 'alain.plantec 3/30/2009 13:23' prior: 0!
A PragmaHandler is a handler for a pragma. Ii is used used by PragmaCollector: PragmaCollector contents is made of a collection of PragmaHandler (or of one of its subclasses) instances .

Instance Variables
	pragma:		<Pragma>

!

!PragmaHandler classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/22/2009 11:07'!
pragma: aPragma
	^ self new pragma: aPragma
! !

!PragmaHandler methodsFor: 'tools' stamp: 'alain.plantec 3/23/2009 10:12'!
browseDeclaration
	ToolSet browse: self methodClass selector: self selector! !

!PragmaHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/22/2009 10:35'!
keyword
	^ pragma keyword! !

!PragmaHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/22/2009 11:29'!
method
	^ pragma method! !

!PragmaHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 15:24'!
methodClass
	^ pragma ifNotNil: [pragma methodClass]! !

!PragmaHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/22/2009 11:31'!
methodReference
	^ self method ifNotNil: [:m | m methodReference]! !

!PragmaHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 08:40'!
package
	^ PackageOrganizer default
				mostSpecificPackageOfClass: self methodClass
				ifNone: []! !

!PragmaHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/21/2009 10:02'!
pragma
	^ pragma! !

!PragmaHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/21/2009 10:03'!
pragma: aPragma
	pragma := aPragma! !

!PragmaHandler methodsFor: 'dependents access' stamp: 'alain.plantec 3/28/2009 10:57'!
release
	pragma := nil.
	super release! !

!PragmaHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 15:25'!
selector
	^ pragma ifNotNil: [pragma selector]! !

PragmaHandler subclass: #SettingHandler
	instanceVariableNames: 'receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingHandler classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/28/2009 10:35'!
pragma: aPragma receiver: aReceiver
	^ (self pragma: aPragma) receiver: aReceiver! !

!SettingHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 09:23'!
description
	^ self value description! !

!SettingHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/28/2009 10:36'!
receiver
	^ receiver! !

!SettingHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/28/2009 10:36'!
receiver: aReceiver
	receiver := aReceiver! !

!SettingHandler methodsFor: 'dependents access' stamp: 'alain.plantec 3/28/2009 10:57'!
release
	receiver := nil.
	super release! !

!SettingHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/28/2009 14:07'!
signature
	^ self receiver class printString, '>>', self selector! !

!SettingHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/28/2009 10:37'!
value
	^ self receiver perform: self selector! !

Object subclass: #PragmaSetting
	instanceVariableNames: 'name parent description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!PragmaSetting commentStamp: 'alain.plantec 3/27/2009 09:53' prior: 0!
A PragmaSetting is a holder for a setting. 
A setting is a particular method which is defined whith a pragma (as examples, <menu> or <setting>). 
Settings can be collected on the fly by a PragmaCollector.
Settings are organized in trees. The parent instance variable is set to nil when the setting is a root. 
Instances of concrete subclasses of PragmaSetting should not be created directly, instead, SettingManager
must be used for that purpose.
Examples of setting definition are given in SettingManager comment.

Instance Variables
	description:		<String> 
	name:		<String>
	parent:		<aSymbol>

description
	- the description that is used in ballon help or by supporting tools (optional)

name
	- the name of the setting

parent
	- a symbol which is the method selector of the parent setting
!

PragmaSetting subclass: #MenuSettingNode
	instanceVariableNames: 'line order enablement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Menu-Core'!

!MenuSettingNode commentStamp: 'alain.plantec 3/27/2009 13:01' prior: 0!
A MenuSettingNode is a setting used to define a menu item.

Instance Variables
	enablement:		<aBoolean>
	line:		<aBoolean>
	order:		<aNumber>

enablement
	- aBoolean used as the enablement of the related menu item

line
	- true if one want a menu line to be added after the item in the resulting gui menu

order
	- aNumber which is used for sibling items ordering
!

MenuSettingNode subclass: #MenuElement
	instanceVariableNames: 'target selector arguments icon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Menu-Core'!

!MenuElement commentStamp: 'alain.plantec 3/27/2009 13:47' prior: 0!
A MenuElement specifies a concrete menu item. 
Such a menu item can perform an action when selected or be used as a node in a menu tree.
The action is perform by sending the message which name is selector to the target.

Instance Variables
	arguments:		<Collection
	icon:		<Form>
	selector:		<Symbol>
	target:		<Object>

arguments
	- a collection which serves as argument list when evaluating the menu element action

icon
	- icon used in the menu item

selector
	- a symbol which represent the message selector to send to the target in order to perform an action when the menu item is selected

target
	- the receiver for the menu item action (receives the message which selector is selector value)!

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/27/2009 12:58'!
arguments
	^ arguments ifNil: [#()]! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 20:46'!
arguments: aCollection
	arguments := aCollection! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 10:13'!
children
	^#()! !

!MenuElement methodsFor: 'testing' stamp: 'alain.plantec 3/26/2009 11:12'!
enabled
	^ self enablement! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/27/2009 12:59'!
icon
	^ icon ! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/27/2009 12:59'!
icon: aForm
	icon := aForm! !

!MenuElement methodsFor: 'menu assembling' stamp: 'alain.plantec 3/27/2009 13:00'!
menuItemIn: aMenu 
	| newItem |
	aMenu
		addToggle: self name
		target: self target 
		selector: self selector
		getStateSelector: nil
		enablementSelector: self enablement
		argumentList: self arguments.
	newItem := aMenu lastItem.
	newItem icon: self icon.
	newItem setBalloonText: description.
	self line ifTrue: [aMenu addLine].
	^ newItem
! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/27/2009 12:59'!
selector
	^ selector ! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/27/2009 12:59'!
selector: aSymbol
	selector := aSymbol! !

!MenuElement methodsFor: 'menu assembling' stamp: 'alain.plantec 3/27/2009 13:00'!
subMenuItemIn: aMenu 
	| sub |
	sub := MenuMorph new.
	aMenu
		add: self name
		subMenu: sub
		target: self target 
		selector: self selector
		argumentList: self arguments.
	aMenu lastItem icon: self icon.
	aMenu lastItem setBalloonText: description.
	self line ifTrue: [aMenu addLine].
	^ sub! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/27/2009 12:59'!
target
	^ target ! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/27/2009 12:59'!
target: anObject
	target := anObject! !

!MenuElement methodsFor: 'reliability' stamp: 'alain.plantec 3/27/2009 13:11'!
testIt
	^ super testIt
		and: [(self icon isNil
					or: [self icon isKindOf: Form])
				and: [(self arguments isKindOf: Collection)
						and: [self selector isNil 
								or: [(self selector isKindOf: Symbol)
										and: [self target respondsTo: self selector]]]]]! !

!MenuSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/27/2009 12:58'!
enablement
	^ enablement ifNil: [true]! !

!MenuSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/27/2009 12:58'!
enablement: aBoolean
	enablement := aBoolean! !

!MenuSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 22:12'!
line
	^ line ifNil: [line := false]! !

!MenuSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 22:12'!
line: aBoolean
	line := aBoolean! !

!MenuSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/26/2009 11:18'!
order
	^ order ifNil: [order := 0]! !

!MenuSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/26/2009 11:10'!
order: aNumber
	order := aNumber! !

!MenuSettingNode methodsFor: 'sorting' stamp: 'alain.plantec 3/30/2009 15:26'!
sort
! !

!MenuSettingNode methodsFor: 'reliability' stamp: 'alain.plantec 3/27/2009 10:22'!
testIt
	^ super testIt and: [
		(self enablement isKindOf: Boolean)
		and: [(self order isKindOf: Number)
				and: [self line isKindOf: Boolean]]]! !

MenuSettingNode subclass: #MenuSiblings
	instanceVariableNames: 'menus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Menu-Core'!

!MenuSiblings commentStamp: 'alain.plantec 3/31/2009 08:10' prior: 0!
A MenuSiblings represents a collection a menu nodes. It is defined for convenience: it allows the declaration of a list of menu items for one level of the menu tree with only one method. 
If a name is set, then, a menu item is created with the name and the siblings are accessed from that item. Thus, If a name is set, a new level is introduced in the menu tree. If a name is not set, then siblings are directly inserted without introducing a new level in the tree.

Instance Variables
	menus:		<Collection of MenuSettingNode>

!

!MenuSiblings methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 10:13'!
children
	^ menus! !

!MenuSiblings methodsFor: 'menu assembling' stamp: 'alain.plantec 3/26/2009 09:58'!
menuItemIn: aMenu 
	| sub item |
	name
		ifNil: [sub := aMenu]
		ifNotNil: [item := MenuItemMorph new.
			sub := MenuMorph new.
			item contents: self name;
				 isEnabled: true;
				 subMenu: sub.
			aMenu addMorphBack: item].
	self children
		do: [:c | 
			c menuItemIn: sub. 
			sub lastItem setBalloonText: description].
	self line
		ifTrue: [aMenu addLine].
	^ sub! !

!MenuSiblings methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 00:07'!
menus
	^ menus! !

!MenuSiblings methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 15:16'!
menus: aCollectionOfMenuSettings
	menus := aCollectionOfMenuSettings.
	aCollectionOfMenuSettings do: [:s | s parent: self parent].
	self sort
	! !

!MenuSiblings methodsFor: 'sorting' stamp: 'alain.plantec 3/30/2009 15:51'!
sort
	menus := (menus asSortedCollection: SettingManager menuItemSortBlock) asOrderedCollection.
	menus do: [:item | item sort]! !

!MenuSiblings methodsFor: 'reliability' stamp: 'alain.plantec 3/27/2009 13:14'!
testIt
	super testIt
		ifFalse: [^ false].
	self menus
		do: [:m | 
			(m isKindOf: MenuSettingNode)
				ifFalse: [^ false].
			m testIt
				ifFalse: [^ false]].
	^ true ! !

!PragmaSetting methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/11/2009 15:38'!
asString
	^ self name! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 19:36'!
description
	"Answer the value of description"

	^ description ifNil: [description := self name]! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 19:36'!
description: aText
	"Set the value of description"

	description := aText! !

!PragmaSetting methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 12:58'!
enabled
	^ true! !

!PragmaSetting methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/4/2009 11:33'!
icon
	^ MenuIcons smallConfigurationIcon! !

!PragmaSetting methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 17:15'!
inputMorphFor: aContainer 
	^ self inputWidget
		ifNotNil: [:iw | 
			| row | 
			iw model: self.
			row := UITheme current newRowIn: World for: {iw}.
			row hResizing: #rigid;
				 clipSubmorphs: true;
				width: (self inputWidgetWidth: iw);
				 cellInset: 0]! !

!PragmaSetting methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/31/2009 08:14'!
inputWidget
	"nothing to input here"
	^ nil! !

!PragmaSetting methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 17:13'!
inputWidgetWidth: inputWidget
	^ inputWidget width
! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 3/26/2009 08:31'!
name
	^ name ifNil: [super name]! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 3/4/2009 10:31'!
name: aName
	name := aName! !

!PragmaSetting methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/11/2009 19:58'!
nameMorph
	^ UITheme current windowLabelForText: self name ! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 3/3/2009 15:21'!
parent
	^ parent! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 3/4/2009 10:31'!
parent: anObject
	"Set the value of parent"

	parent := anObject! !

!PragmaSetting methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 09:39'!
rowMorphListFor: aContainer
	| controls |
	controls := OrderedCollection with: self nameMorph.
	(self inputMorphFor: aContainer) ifNotNil: [:im | controls add: im].
	^ controls! !

!PragmaSetting methodsFor: 'reliability' stamp: 'alain.plantec 3/27/2009 10:22'!
testIt
	"nothing to be done here"
	^ true! !

PragmaSetting subclass: #SystemSettingNode
	instanceVariableNames: 'dialog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!SystemSettingNode commentStamp: 'alain.plantec 3/31/2009 08:25' prior: 0!
SystemSettingNode is the root class of all setting classes for preference settings.
A SystemSettingNode can be instanciated. Such a node don't holds any value but is used as 
a named node in order to organize the preference tree.
A Setting node can be associated with a dialog symbol which is the name of a dialog class 
that responds to the #open message.

Instance Variables
	dialog:		<Symbol>

!

SystemSettingNode subclass: #AbstractSettingValue
	instanceVariableNames: 'realValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!AbstractSettingValue commentStamp: 'alain.plantec 3/31/2009 08:13' prior: 0!
An AbstractSettingValue is a setting which holds a real value for a setting.

Instance Variables
	realValue:		<Object>

realValue
	- xxxxx
!

!AbstractSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/19/2009 10:06'!
hasValue
	^ true! !

!AbstractSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/5/2009 16:21'!
icon
	^ MenuIcons smallPaintIcon! !

!AbstractSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/11/2009 12:56'!
nameMorph
	^ UITheme current newLabelIn: World for: self label: self name getEnabled: nil! !

!AbstractSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/4/2009 10:54'!
realValue
	"Answer the value of realValue"

	^ realValue! !

!AbstractSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/4/2009 10:54'!
realValue: anObject
	"Set the value of realValue"

	realValue := anObject! !

!AbstractSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 08:40'!
value
	^ self realValue value! !

AbstractSettingValue subclass: #FixedSettingValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!FixedSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 18:36'!
asString
	^ self name! !

!FixedSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 21:19'!
icon
	^ MenuIcons smallHelpIcon! !

!FixedSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/24/2009 23:19'!
settingFixedDomainValueNodeFrom: aSettingNode 
	^ self! !

!FixedSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 20:11'!
value: anObject
	^ self realValue: anObject! !

AbstractSettingValue subclass: #SettingValue
	instanceVariableNames: 'type default list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!SettingValue commentStamp: '<historical>' prior: 0!
A SettingValue is an handler for a setting value. 
Its main responsibility is hold descriptive data and to notify all listeners when the setting value is changed.
see #value: method which is call in order to change a setting value.

Instance Variables
	type:			<Object>
	default:		<Object>
	list:		<Object>
!

SettingValue subclass: #FixedMultipleSettingValue
	instanceVariableNames: 'domainValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!FixedMultipleSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/13/2009 09:24'!
default
	^ default ifNil: [default := self domainValues first value]! !

!FixedMultipleSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 14:30'!
domainValues
	^ domainValues ! !

!FixedMultipleSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 23:19'!
domainValues: aCollection 
	domainValues := aCollection asOrderedCollection collect: [ :v | (v settingFixedDomainValueNodeFrom: self) parent: self ]! !

!FixedMultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/11/2009 16:28'!
dropListValues
	^ self domainValues collect: [:i | i name]! !

!FixedMultipleSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 23:20'!
fixedDomainValueNodeForAssociation: anAssociation 
	^ (SettingManager newFixed: anAssociation key)
		description: anAssociation key;
		value: anAssociation value! !

!FixedMultipleSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 23:21'!
fixedDomainValueNodeForObject: anObject 
	^ (SettingManager newFixed: anObject asString)
		description: anObject asString;
		value: anObject! !

!FixedMultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 22:55'!
haveEditableList
	^ false! !

!FixedMultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 21:14'!
index
	self value ifNil: [self value: self default].
	^ self domainValues indexOf: (self domainValues detect: [:dv | dv value = self value] ifNone: [^ 0])! !

!FixedMultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 21:15'!
index: anInteger
	self value: (self domainValues at: anInteger) value.
! !

!FixedMultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 18:31'!
inputWidget
	| dropList |
	dropList := UITheme current
				newDropListIn: World
				for: self
				list: #list
				getSelected: #index
				setSelected: #index:
				getEnabled: #enabled
				useIndex: true
				help: self description.
	dropList extent: 1 @ 30.
	^ dropList! !

!FixedMultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 09:14'!
inputWidgetWidth: inputWidget
	^ (self maxNameWidthForFont: inputWidget font) + 40

! !

!FixedMultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 18:38'!
list
	^ list ifNil: [list := self domainValues collect: [:i | i name]]! !

!FixedMultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 18:43'!
maxNameWidthForFont: aFont 
	| max |
	max := 0.
	self list
		do: [:v | max := max max: (aFont widthOfStringOrText: v)].
	^ max ! !

SettingValue subclass: #MultipleSettingValue
	instanceVariableNames: 'getter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!MultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/16/2009 11:09'!
chooseValue
	| chosen |
	chosen := UIManager default
				chooseFrom: self domainValueLabels
				values: (self domainValues asSortedCollection: [:a :b | a asString < b asString])
				title: 'Choose ' translated , self name translated.
	chosen 
		ifNotNil: [self addToList: chosen. self value: chosen. ]! !

!MultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/16/2009 10:54'!
domainValueLabels
	^ (self domainValues collect: [:e | e asString]) asSortedCollection! !

!MultipleSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 10:13'!
domainValues
	^ getter value asOrderedCollection! !

!MultipleSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 09:54'!
getter: aValuable 
	getter := aValuable! !

!MultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/16/2009 09:50'!
haveEditableList
	^ false! !

!MultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/16/2009 11:19'!
inputMorphFor: aContainer 
	| inputMorph label |
	inputMorph := super inputMorphFor: aContainer.
	label := EditableDropListMorph
				on: self
				list: #list
				selected: #index
				changeSelected: #index:
				useIndex: true 
				addToList: nil
				class: nil
				getEnabled: #enabled.
	label height: label font height + 8.
	label width: self maxLabelWidth + 30.
	label contentMorph lock. 
	inputMorph addMorphBack: label.
	inputMorph layoutPolicy: TableLayout new.
	inputMorph hResizing: #shrinkWrap.
	inputMorph cellInset: 10.
	inputMorph fullBounds.
	inputMorph
		submorphsDo: [:sm | sm minHeight: label height].
	^ inputMorph! !

!MultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/16/2009 09:59'!
inputWidget
	^ (UITheme current
		newButtonIn: World
		for: self
		getState: nil
		action: #chooseValue 
		arguments: {}
		getEnabled: #enabled
		getLabel: nil
		help: 'Choose a value for ' translated , self name translated) label: 'Choose...';
		 yourself! !

!MultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/16/2009 10:52'!
maxLabelWidth
	^ (self domainValueLabels collect: [:e | UITheme current textFont widthOfStringOrText: e]) detectMax: [:e | e]
! !

SettingValue subclass: #RangeSettingValue
	instanceVariableNames: 'range'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!RangeSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 22:55'!
haveEditableList
	^ false! !

!RangeSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 16:47'!
inputMorphFor: aContainer
	| inputMorph textInput |
	inputMorph := super inputMorphFor: aContainer.
	textInput :=  (UITheme current
		newTextEntryIn: World 
		for: self
		get: #value
		set: #value:
		class: (Smalltalk at: self type)
		getEnabled: #enabled
		help: nil) hResizing: #rigid;
		width: 80.
	inputMorph addMorphFront: textInput.
	inputMorph layoutPolicy: TableLayout new.
	inputMorph hResizing: #shrinkWrap.
	inputMorph cellInset: 10.
	inputMorph fullBounds.
	inputMorph submorphsDo: [:sm | sm minHeight: textInput height].
	^ inputMorph
	! !

!RangeSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/16/2009 14:27'!
inputWidget
	"^ (UITheme current
	newSliderIn: World
	for: self 
	getValue: #value
	setValue: #value:
	min: self range first
	max: self range last
	quantum: self range increment
	getEnabled: #enabled
	help: self description) minWidth: 300; yourself"
	^ (PluggableSliderMorph new max: self range last;
		 min: self range first;
		 quantum: self range increment;
		 on: self
		 getValue: #value
		 setValue: #value:) hResizing: #spaceFill;
		 vResizing: #spaceFIll;
		 setBalloonText: self description;
		 minWidth: 300;
		 yourself! !

!RangeSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/12/2009 16:19'!
range
	^ range ! !

!RangeSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/3/2009 09:38'!
range: anInterval
	range := anInterval! !

!RangeSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/12/2009 16:44'!
value: aValue
	super value: ((aValue max: self range first) min: self range last).
	! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 12:56'!
addToList: anItem 
	(self list includes: anItem)
		ifFalse: [self list size > 5 ifTrue: [self list removeFirst].
			self list add: anItem. 
			self changed: #list]! !

!SettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/2/2009 14:25'!
changeEvent
	^ #valueChanged ! !

!SettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 19:40'!
default
	^ default ! !

!SettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 19:25'!
default: anObject
	default := anObject.
	realValue := anObject! !

!SettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/4/2009 11:48'!
defaultValue
	^ default value! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 23:10'!
emptyList
	list := nil.
	self addToList: self value.
! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 15:35'!
enablementChanged
	self changed: #enabled.
! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 15:39'!
fontButtonLabel
	| emphases |
	emphases := IdentityDictionary new at: nil put: 'Regular' translated;
				 at: 0 put: 'Regular' translated;
				 at: 1 put: 'Bold' translated;
				 at: 2 put: 'Italic' translated;
				 at: 4 put: 'Underlined' translated;
				 at: 8 put: 'Narrow' translated; 
				 at: 16 put: 'StruckOut' translated;
				 yourself.
	^ StringMorph contents: self value familyName , ' '
			, (emphases
					at: self value emphasis
					ifAbsent: ['']) , ' ' , self value pointSize asString font: self value! !

!SettingValue methodsFor: 'notification' stamp: 'alain.plantec 3/12/2009 12:10'!
forget: aReceiver
	self removeActionsWithReceiver: aReceiver forEvent: self changeEvent.
! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 15:39'!
getFont
	^ FontChooser
		openWithWindowTitle: 'Font for ' , self name
		for: self
		setSelector: #value:
		getSelector: #value ! !

!SettingValue methodsFor: 'testing' stamp: 'alain.plantec 3/13/2009 22:45'!
haveDefault
	^ true! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 22:55'!
haveEditableList
	^ true! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/16/2009 16:43'!
icon
	^ self type = #LogicalFont ifTrue: [MenuIcons smallFontsIcon]
	ifFalse: [super icon]! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/19/2009 10:17'!
index
	self value
		ifNil: [self list
				ifNotEmpty: [:l | self value: l first]].
	^ self list
		indexOf: self value
		ifAbsent: [self addToList: self value. self list size]! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 21:19'!
index: anInteger
	self value: (self list at: anInteger).
! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 17:12'!
inputMorphFor: aContainer
	^ (super inputMorphFor: aContainer)
		ifNotNil: [:im | 
				self whenChangedSend: #valueChanged to: self.
				self whenChangedSend: #enablementChanged to: self.
				self whenChangedSend: #innerWidgetChanged to: aContainer.
				im]! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:36'!
inputWidget
	| inputWidget |
	inputWidget := self typeClass
						ifNil: [self localInputWidgetSelector 
							ifNotNil: [:localSel | self perform: localSel]]
						ifNotNil: [:cls | (self inputWidgetSelectorInClass: cls)
							ifNotNil: [:selector | cls perform: selector with: self]].
	inputWidget
		ifNotNil: [inputWidget model: self].
	^ inputWidget! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 15:59'!
inputWidgetForBoolean
	^ UITheme current
			newCheckboxIn: World
			for: self
			getSelected: #value
			setSelected: #value:
			getEnabled: #enabled
			label: '' 
			help: nil! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 16:55'!
inputWidgetForColor
	^ (UITheme current
		newColorChooserIn: World
		for: self
		getColor: #value
		setColor: #value:
		getEnabled: #enabled 
		help: 'Choose a color') minWidth: 150; yourself! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 14:49'!
inputWidgetForFont
	^ UITheme current
		newButtonIn: World
		for: self
		getState: nil 
		action: #getFont
		arguments: {}
		getEnabled: #enabled
		getLabel: #fontButtonLabel
		help: 'Choose a font ...' translated
! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:05'!
inputWidgetForNumber
	^ self inputWidgetForString width: 200.
! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:03'!
inputWidgetForString
	| widget |
	widget := EditableDropListMorph
				on: self
				list: #list
				selected: #index
				changeSelected: #index:
				useIndex: true 
				addToList: #addToList:
				class: (Smalltalk at: self type)
				getEnabled: #enabled.
	widget height: widget font height + 8;
		width: 450.
	^ widget! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:34'!
inputWidgetSelectorInClass: aClass
	| selector |
	^ (aClass respondsTo: (selector := #settingInputWidgetForNode:)) ifTrue: [selector]! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 21:31'!
list
	^ list
		ifNil: [list := OrderedCollection new.
			self default ifNotNil: [:d | list add: d value].
			list] ! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:33'!
localInputWidgetSelector
	| imSel |
	^ (self respondsTo: (imSel := ('inputWidgetFor' , self type) asSymbol)) ifTrue: [imSel]! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 22:41'!
setToDefault
	self value: self defaultValue! !

!SettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 18:39'!
type
	"Answer the value of type"

	^ type ifNil: [type := self value class name]! !

!SettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 18:22'!
type: anObject
	"Set the value of type"

	type := anObject! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:12'!
typeClass
	^ Smalltalk at: self type ifAbsent: []
! !

!SettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/12/2009 12:11'!
value: anObject 
	realValue ~= anObject
		ifTrue: [realValue := anObject.
			self triggerEvent: self changeEvent with: anObject]! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 18:13'!
valueChanged
	self changed: #value.
	self changed: #fontButtonLabel.
	self changed: #index.
	self changed: #content.
! !

!SettingValue methodsFor: 'notification' stamp: 'alain.plantec 3/12/2009 04:59'!
whenChangedSend: zeroOrOneArgSelector to: aSubscriber
	self when: self changeEvent send: zeroOrOneArgSelector to: aSubscriber! !

!SystemSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 20:42'!
dialog
	^ dialog! !

!SystemSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 20:42'!
dialog: aSymbol
	dialog := aSymbol! !

!SystemSettingNode methodsFor: 'testing' stamp: 'alain.plantec 3/24/2009 20:52'!
hasValue
	^ false! !

!SystemSettingNode methodsFor: 'testing' stamp: 'alain.plantec 3/24/2009 20:52'!
haveDefault
	^ false! !

!SystemSettingNode methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/24/2009 20:53'!
haveEditableList
	^ false! !

!SystemSettingNode methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/24/2009 20:54'!
inputWidget
	^ (self dialog notNil
			and: [(Smalltalk
					at: self dialog
					ifAbsent: []) notNil])
		ifTrue: [(UITheme current
				newButtonIn: World
				for: self
				getState: nil
				action: #openDialog 
				arguments: {}
				getEnabled: #enabled
				getLabel: nil
				help: 'Advanced dialog for ' translated, self name translated) label: self name, '...';
				 yourself]! !

!SystemSettingNode methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/24/2009 20:55'!
openDialog
	(Smalltalk at: self dialog asSymbol) open! !

Object subclass: #SettingFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Filter'!

!SettingFilter commentStamp: 'alain.plantec 3/25/2009 22:36' prior: 0!
A SettingFilter is a filter wich is used by a SettingTree in order to filter viewed nodes. 
A particular filter must redefine #keepHandler: method which return true if the argument handler
is to be kept.

Instance Variables
!

!SettingFilter methodsFor: 'filtering' stamp: 'alain.plantec 3/25/2009 22:39'!
keepHandler: aSettingHandler 
	^ false! !

SettingFilter subclass: #SettingPackageFilter
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Filter'!

!SettingPackageFilter commentStamp: 'alain.plantec 3/25/2009 22:38' prior: 0!
A SettingPackageFilter is SettingFilter which keeps only handlers from a given package

Instance Variables
	packages:		<Object>

packages
	- xxxxx
!

!SettingPackageFilter methodsFor: 'filtering' stamp: 'alain.plantec 3/25/2009 22:39'!
keepHandler: aSettingHandler 
	^ self packages includes: aSettingHandler package! !

!SettingPackageFilter methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 23:00'!
packages
	"Answer the value of packages"

	^ packages! !

!SettingPackageFilter methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 23:01'!
packages: aCollectionOfPackages
	"Set the value of packages"

	packages := aCollectionOfPackages! !

SettingFilter subclass: #SettingSearchTokenFilter
	instanceVariableNames: 'token'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Filter'!

!SettingSearchTokenFilter commentStamp: 'alain.plantec 3/25/2009 22:39' prior: 0!
A SettingSearchTokenFilter is filter which keeps only handler with a given token.


Instance Variables
	token:		<Object>

token
	- xxxxx
!

!SettingSearchTokenFilter methodsFor: 'filtering' stamp: 'alain.plantec 3/25/2009 22:41'!
keepHandler: aSettingHandler 
	^ (({aSettingHandler methodClass name asUppercase. aSettingHandler selector asUppercase}
			collect: [:e | e
					ifNil: ['']])
			includesSubstringAnywhere: self token asUppercase)
		or: [self keepValue: aSettingHandler value]! !

!SettingSearchTokenFilter methodsFor: 'filtering' stamp: 'alain.plantec 3/25/2009 22:40'!
keepValue: aSettingNode
	^ (({aSettingNode name asUppercase. aSettingNode description asUppercase}
				collect: [:e | e ifNil: ['']])
				includesSubstringAnywhere: self token asUppercase)
! !

!SettingSearchTokenFilter methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 22:51'!
token
	"Answer the value of token"

	^ token! !

!SettingSearchTokenFilter methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 22:51'!
token: aString
	"Set the value of token"

	token := aString! !

Object subclass: #SettingManager
	instanceVariableNames: ''
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!SettingManager classSide methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 12:27'!
current
	"Answer the current manager."

	^Current ifNil: [Current := SettingManager new]! !

!SettingManager classSide methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 15:50'!
menuItemSortBlock
	^ [:a :b | a order = b order
						ifTrue: [a name < b name]
						ifFalse: [a order < b order]]! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/17/2009 09:31'!
newFixed: aName
	^ self current newFixed: aName! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/16/2009 13:33'!
newFixedMultiple: aName
	^ self current newFixedMultiple: aName! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/24/2009 21:08'!
newMenu: aName 	
	^ self current newMenu: aName ! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/25/2009 00:12'!
newMenuSiblings
	^ self current newMenuSiblings! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/26/2009 11:42'!
newMenuSiblings: aName
	^ self current newMenuSiblings: aName
! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/16/2009 13:32'!
newMultiple: aName
	^ self current newMultiple: aName! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/16/2009 13:25'!
newNode: aName
	^ self current newNode: aName! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/16/2009 13:30'!
newRange: aName
	^ self current newRange: aName! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/16/2009 13:22'!
newSetting: aName
	^ self current newSetting: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 09:22'!
newFixed: aName 
	^ FixedSettingValue new name: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 09:22'!
newFixedMultiple: aName 
	^ FixedMultipleSettingValue new name: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 19:02'!
newMenu: aName 
	^ MenuElement new name: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 00:12'!
newMenuSiblings
	^ MenuSiblings new ! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/26/2009 11:42'!
newMenuSiblings: aName
	^ self newMenuSiblings name: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 09:22'!
newMultiple: aName 
	^ MultipleSettingValue new name: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 19:08'!
newNode: aName  
	^ SystemSettingNode new name: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 09:22'!
newRange: aName 
	^ RangeSettingValue new name: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 09:22'!
newSetting: aName 
	^ SettingValue new name: aName! !

Object subclass: #SettingMenuAssembler
	instanceVariableNames: 'treeBuilder menuTitle discoveredMenu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Menu-Assembler'!

!SettingMenuAssembler classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/30/2009 21:36'!
forKeywords: aCollectionOfRegExps 
	^ self new acceptableKeywords: aCollectionOfRegExps! !

!SettingMenuAssembler classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/30/2009 21:58'!
worldMenuAssembler
	^ (self forKeywords: #('worldMenu' )) menuTitle: 'World menu'! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 21:37'!
acceptableKeywords: aCollectionOfRegExps 
	self treeBuilder acceptableKeywords: aCollectionOfRegExps! !

!SettingMenuAssembler methodsFor: 'menu building' stamp: 'alain.plantec 3/30/2009 23:47'!
buildMenu
	| treeRoots menu |
	treeRoots := self treeBuilder buildTree.
	menu := MenuMorph new.
	menu title: self menuTitle.
	menu addStayUpItem.
	treeRoots
		do: [:c | self node: c menuItemIn: menu].
	^ menu! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 16:58'!
defaultMenuTitle
	^ 'Menu'! !

!SettingMenuAssembler methodsFor: 'menu building' stamp: 'alain.plantec 3/25/2009 18:58'!
discoveredMenu
	^ discoveredMenu ifNil: [discoveredMenu := self buildMenu]
! !

!SettingMenuAssembler methodsFor: 'menu building' stamp: 'alain.plantec 3/25/2009 18:56'!
doPopUpMenu
	self discoveredMenu popUpEvent: nil in: World
! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 16:38'!
itemSortBlock
	^ [:a :b | SettingManager menuItemSortBlock value: a value value: b value]! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 16:58'!
menuTitle
	^ menuTitle ifNil: [menuTitle := self defaultMenuTitle]! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 18:26'!
menuTitle: aTitle
	menuTitle := aTitle! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 22:27'!
newTreeBuilder
	^ SettingTreeBuilder new client: self;
		 handlerClass: SettingHandler! !

!SettingMenuAssembler methodsFor: 'menu building' stamp: 'alain.plantec 3/30/2009 22:52'!
node: aTreeNode menuItemIn: aMenu 
	| sub |
	aTreeNode contents
		ifEmpty: [aTreeNode item value menuItemIn: aMenu]
		ifNotEmpty: [sub := aTreeNode item value subMenuItemIn: aMenu.
			aTreeNode contents
				do: [:c | c item value menuItemIn: sub]]! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 21:17'!
receiver: anObject 
	self treeBuilder receiver: anObject! !

!SettingMenuAssembler methodsFor: 'dependents access' stamp: 'alain.plantec 3/30/2009 23:46'!
release
	treeBuilder release.
	treeBuilder := nil.
	super release! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 21:51'!
treeBuilder
	^ treeBuilder
		ifNil: [treeBuilder := self newTreeBuilder]! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 23:07'!
treeNodeClass
	^ SettingTreeNode! !

Object subclass: #SettingStyle
	instanceVariableNames: 'status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Style'!

SettingStyle subclass: #DefaultSettingStyle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Style'!

!DefaultSettingStyle class methodsFor: 'accessing' stamp: 'alain.plantec 3/31/2009 09:33'!
styleName
	^ 'Default' translated! !

!DefaultSettingStyle methodsFor: 'loading' stamp: 'alain.plantec 3/31/2009 09:45'!
load
! !

!SettingStyle classSide methodsFor: 'accessing' stamp: 'alain.plantec 3/19/2009 13:27'!
styleName
	^ self subclassresponsibility ! !

!SettingStyle methodsFor: 'loading' stamp: 'alain.plantec 3/19/2009 08:24'!
load
	^ self subclassResponsibility! !

!SettingStyle methodsFor: 'loading' stamp: 'alain.plantec 3/31/2009 09:36'!
loadStyle
	self load. 
	Transcript show: 'Setting style ', self class styleName, ' loaded.' , String cr! !

!SettingStyle methodsFor: 'loading' stamp: 'alain.plantec 3/31/2009 09:36'!
loadStyleFrom: aRequestor 
	status := aRequestor status.
	self load.
	status nextPutAll: 'Setting style ', self class styleName, ' loaded.';
		 cr ! !

Object subclass: #SettingTreeBuilder
	instanceVariableNames: 'client collector receiver acceptableKeywords nodeClass handlerClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 21:24'!
acceptableKeywords
	^ acceptableKeywords ! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 21:23'!
acceptableKeywords: aCollectionOfRegExps 
	acceptableKeywords := aCollectionOfRegExps asSet! !

!SettingTreeBuilder methodsFor: 'tree building' stamp: 'alain.plantec 3/30/2009 16:12'!
buildTree
	| r |
	r := ((self collector
				select: [:p | p value parent isNil]) asArray sort: self client itemSortBlock) asOrderedCollection
				collect: [:d | self nodeClass with: d model: self].
	r
		do: [:n | n buildContents]. 
	^ self withUnclassifiedIn: r asOrderedCollection! !

!SettingTreeBuilder methodsFor: 'querying' stamp: 'alain.plantec 3/24/2009 21:49'!
childrenOf: aSettingHandler
	^ (self nonRoots select: [:p | p value notNil]) 
			select: [:p | p value parent = aSettingHandler selector]! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 11:27'!
client
	^ client! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 21:48'!
client: aClient 
	client := aClient.
	self nodeClass: client treeNodeClass.
! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 20:11'!
collector
	^ collector
		ifNil: [collector := PragmaCollector client: self.
			self prepareCollector.
			collector reset]! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 22:06'!
handlerClass
	^ handlerClass! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 22:06'!
handlerClass: aPragmaHandlerClass
	handlerClass := aPragmaHandlerClass! !

!SettingTreeBuilder methodsFor: 'tree building' stamp: 'alain.plantec 3/30/2009 22:06'!
handlerFromPragma: aPragma 
	^ (self keepPragma: aPragma)
		ifTrue: [self handlerClass
				pragma: aPragma
				receiver: (self receiver
						ifNil: [aPragma methodClass theNonMetaClass])] ! !

!SettingTreeBuilder methodsFor: 'querying' stamp: 'alain.plantec 3/24/2009 21:43'!
hasUnclassified
	^ (self nonRoots detect: [:p | self collector noneSatisfy: [:pp | pp selector = p value parent]] ifNone: []) notNil! !

!SettingTreeBuilder methodsFor: 'testing' stamp: 'alain.plantec 3/30/2009 22:41'!
keepPragma: aPragma
	^ (self receiver
			ifNil: [aPragma methodClass isMeta]
			ifNotNil: [self receiver isKindOf: aPragma methodClass])
		and: [self acceptableKeywords
				anySatisfy: [:rxString | aPragma keyword asString matchesRegex: rxString]]! !

!SettingTreeBuilder methodsFor: 'querying' stamp: 'alain.plantec 3/30/2009 22:03'!
maxNameWidth
	^ ((self collector collect: [:p | UITheme current listFont widthOfStringOrText: p value name]) detectMax: [:l | l ]) ifNil: [60]! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 21:45'!
nodeClass
	^ nodeClass! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 21:39'!
nodeClass: aClass
	nodeClass := aClass! !

!SettingTreeBuilder methodsFor: 'querying' stamp: 'alain.plantec 3/24/2009 21:49'!
nonRoots
	^ self collector reject: [:p | p value parent isNil]
! !

!SettingTreeBuilder methodsFor: 'tree building' stamp: 'alain.plantec 3/30/2009 20:14'!
prepareCollector
	self collector whenChangedSend: #forceRebuild to: self client.
	self collector announcer on: PragmaWithError send: #pragmaErrorOccured: to: self client
! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 21:13'!
receiver
	^ receiver! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 21:13'!
receiver: anObject
	receiver := anObject! !

!SettingTreeBuilder methodsFor: 'dependents access' stamp: 'alain.plantec 3/30/2009 22:45'!
release
	collector release.
	collector := nil.
	client := nil.
	receiver := nil.
	acceptableKeywords := nil.
	nodeClass := nil.
	handlerClass := nil.
	super release! !

!SettingTreeBuilder methodsFor: 'querying' stamp: 'alain.plantec 3/24/2009 21:49'!
unclassified
	^ self nonRoots select: [:p | self collector noneSatisfy: [:pp | (self childrenOf: pp) includes: p]]! !

!SettingTreeBuilder methodsFor: 'tree building' stamp: 'alain.plantec 3/30/2009 23:30'!
withUnclassifiedIn: aCollectionOfNodes
	self hasUnclassified ifTrue: [aCollectionOfNodes addFirst: (UnclassifiedSettingTreeNode model: self)].
	^ aCollectionOfNodes
! !

AbstractHierarchicalList subclass: #SettingBrowser
	instanceVariableNames: 'roots status searchedText treeBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

SettingBrowser subclass: #PackageSettingBrowser
	instanceVariableNames: 'viewedPackages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!PackageSettingBrowser classSide methodsFor: 'opening' stamp: 'alain.plantec 3/30/2009 10:16'!
open
	^ self new open! !

!PackageSettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 3/30/2009 10:18'!
applyFilters
	| filter |
	super applyFilters.
	self viewedPackages
		ifNotEmpty: [filter := SettingPackageFilter new
						packages: self viewedPackages.
			self updateAccordingTo: filter].
	self updateList! !

!PackageSettingBrowser methodsFor: 'UI' stamp: 'alain.plantec 3/30/2009 10:16'!
buildWindowIn: aWindow verticalGap: startGap 
	| statusView toolBar treeMorph toolBarY gap localGap packageListView |
	treeMorph := self treeMorphIn: aWindow.
	statusView := self statusViewIn: aWindow.
	packageListView := self packageListViewIn: aWindow.
	toolBar := self toolBarIn: aWindow.
	localGap := 5.
	gap := startGap + localGap.
	toolBarY := toolBar minExtent y + gap.
	aWindow 
		addMorph: toolBar
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ (gap ) corner: 0 @ (toolBarY + localGap))).
	aWindow 
		addMorph: treeMorph
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0.99)
				offsets: (0 @ (toolBarY + localGap + localGap) corner: 0 @ 100 negated)).
	aWindow 
		addMorph: statusView
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0.99 corner: 0.55 @ 1)
				offsets: (0 @ 100 negated corner: 0 @ 0)).
	aWindow 
		addMorph: packageListView
		fullFrame: (LayoutFrame 
				fractions: (0.55 @ 0.99 corner: 1 @ 1)
				offsets: (0 @ 100 negated corner: 0 @ 0)).
	^ aWindow! !

!PackageSettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 3/30/2009 10:16'!
changePackageSet: aSet 
	| |
	aSet ~= self viewedPackages
		ifTrue: [roots := nil.
			self viewedPackages: aSet.
			self applyFilters ].
	^ true! !

!PackageSettingBrowser methodsFor: 'UI' stamp: 'alain.plantec 3/30/2009 10:16'!
choosePackagesIn: aWindow
	| chooser allPackages chosen |
	allPackages := PackageOrganizer default packageNames asSortedCollection.
	chosen := self viewedPackages collect: [:p | p packageName].
	aWindow openModal: (chooser := SettingPackageChooser new chooseFrom: allPackages; chosen: chosen; yourself).
	chooser cancelled
		ifFalse: [self changePackageSet: (chooser chosen collect: [:c | PackageOrganizer default packageNamed: c ifAbsent: []])] ! !

!PackageSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 10:35'!
getDescription
	^ self getCurrentSelection
		ifNil: [status contents]
		ifNotNil: [:selection | Text
				streamContents: [:s |
					selection package ifNotNil: [:pkg |
						s nextPutAll: (Text string: 'Package: ', pkg packageName attribute: TextEmphasis bold).
						s nextPut: Character cr].
					s nextPutAll: super getDescription]]! !

!PackageSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 10:16'!
getViewedPackageNames
	^ Text
		streamContents: [:s | self viewedPackages
				ifEmpty: [s nextPutAll: 'All packages']
				ifNotEmpty: [:selections | 
					(selections asSet = MCWorkingCopy allManagers asSet)
						ifTrue: [s nextPutAll: 'All packages']
						ifFalse: [selections
								do: [:package | 
									s nextPutAll: package packageName.
									s nextPut: Character cr]]]]! !

!PackageSettingBrowser methodsFor: 'UI' stamp: 'alain.plantec 3/30/2009 10:16'!
packageListViewIn: aWindow
	^ aWindow
				newTextEditorFor: self
				getText: #getViewedPackageNames
				setText: #setViewedPackageNames:.
! !

!PackageSettingBrowser methodsFor: 'dependents access' stamp: 'alain.plantec 3/30/2009 10:37'!
release
	viewedPackages := nil.
	super release.! !

!PackageSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 10:16'!
setViewedPackageNames: aText 
	| allViewed |
	allViewed := Set new.
	aText asString subStrings
		do: [:sub | (PackageOrganizer default
						packageNamed: sub
						ifAbsent: [])
				ifNotNil: [:pkg | allViewed add: pkg]].
	self changePackageSet: allViewed.
	self changed: #getViewedPackageNames
! !

!PackageSettingBrowser methodsFor: 'UI' stamp: 'alain.plantec 3/30/2009 10:32'!
toolBarIn: aMorph 
	| toolBar |
	toolBar := super toolBarIn: aMorph.
	toolBar
		addMorphBack: (aMorph
				newButtonFor: self
				getState: nil
				action: #choosePackagesIn:
				arguments: {aMorph}
				getEnabled: nil
				label: 'Choose packages' translated 
				help: 'Select packages' translated).
	toolBar addMorphBack: aMorph newToolSpacer.
	^ toolBar! !

!PackageSettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 3/30/2009 10:28'!
updateList
	super updateList.
	self changed: #getViewedPackageNames
	

	
! !

!PackageSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 10:16'!
viewedPackages
	^ viewedPackages
		ifNil: [viewedPackages := Set new]! !

!PackageSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 10:16'!
viewedPackages: aCollectionOfPackagesOrNil
	viewedPackages:= aCollectionOfPackagesOrNil! !

PackageSettingBrowser subclass: #SystemMenuBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Menu-Browser'!

!SystemMenuBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 16:09'!
itemSortBlock
	^ [:a :b | SettingManager menuItemSortBlock value: a value value: b value]! !

!SystemMenuBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/30/2009 23:12'!
keyStroke: aCharacter from: aTreeMorph 
	super keyStroke: aCharacter from: aTreeMorph.
	(self getCurrentSelection)
		ifNotNil: [:current | aCharacter = $p 
				ifTrue: [^ self menuPopUp]]! !

!SystemMenuBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/30/2009 23:06'!
menu: menu shifted: b 
	super menu: menu shifted: b.
	(self getCurrentSelection)
		ifNotNil: [:current | menu
				add: 'Popup (p)' translated
				target: self
				selector: #menuPopUp].
	^ menu! !

!SystemMenuBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/30/2009 23:01'!
menuPopUp
	(self getCurrentSelection)
		ifNotNil: [:current | 
			| menu | 
			menu := MenuMorph new.
			menu title: current item value name.
			menu addStayUpItem.
			self node: current menuItemIn: menu.
			menu popUpEvent: nil in: World]! !

!SystemMenuBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 21:51'!
newTreeBuilder
	^ super newTreeBuilder acceptableKeywords: #('worldMenu' )! !

!SystemMenuBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/30/2009 23:02'!
node: aTreeNode menuItemIn: aMenu 
	| sub |
	aTreeNode contents
		ifEmpty: [aTreeNode item value menuItemIn: aMenu]
		ifNotEmpty: [sub := aTreeNode item value subMenuItemIn: aMenu.
			aTreeNode contents
				do: [:c | c item value menuItemIn: sub]]! !

!SystemMenuBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 23:08'!
treeNodeClass
	^ SettingTreeNode! !

PackageSettingBrowser subclass: #SystemSettingBrowser
	instanceVariableNames: ''
	classVariableNames: 'StyleNameClassSuffix UserStylePackageNamePrefix'
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SystemSettingBrowser classSide methodsFor: 'internal settings' stamp: 'alain.plantec 3/30/2009 11:13'!
styleNameClassSuffix
	<internalSetting>
	^ StyleNameClassSuffix
		ifNil: [StyleNameClassSuffix := (SettingManager newSetting: 'User style classname suffix') description: 'A setting style is stored as a class which name is the style name suffixed with the value of this setting.
As an example, if the value of this setting is "SettingStyle" then, for a style named "Favorite", the corresponding style class name is "FavoriteSettingStyle".';
						 default: 'SettingStyle']! !

!SystemSettingBrowser classSide methodsFor: 'internal settings' stamp: 'alain.plantec 3/30/2009 11:13'!
userStylePackageNamePrefix
	<internalSetting>
	^ UserStylePackageNamePrefix
		ifNil: [UserStylePackageNamePrefix := (SettingManager newSetting: 'User style package') description: 'The name of the package to update or create with user defined styles';
						 default: 'UserDefinedSettings']! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
about
	self inform: 'Here you can browse, query and set all system settings.'! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/30/2009 11:16'!
browseInternalSettings
	((LocalSettingBrowser forKeywords: {self internalSettingKeyword}) receiver: self class) open! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
browseStyle
	| allStyleClasses cls |
	allStyleClasses := (SettingStyle allSubclasses asSortedCollection: [:a :b | a name < b name]) asOrderedCollection.
	cls := UIManager default chooseFrom: (allStyleClasses collect: [:c | c styleName]) values: allStyleClasses.
	cls ifNotNil: [ToolSet browse: cls selector: #load]! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/23/2009 10:31'!
buildDefaultStyle
	| code |
	code := 	code := self styleLoadCode: true.
	SettingStyle
		subclass: self defaultSettingStyleClassName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: SettingStyle category.
	self defaultSettingStyleClass compile: code classified: #loading.
	self defaultSettingStyleClass class
		compile: (('styleName\	^ ''Default'' translated') withCRs)
		classified: #accessing! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/30/2009 21:31'!
buildUserDefinedStyleNamed: aName classname: aClassname code: loadCode
	SettingStyle
		subclass: aClassname
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: (self class userStylePackageNamePrefix value asIdentifier: true), '-Setting-Styles'.
	(Smalltalk at: aClassname) 
		compile: loadCode
		classified: #loading.
	(Smalltalk at: aClassname) class
		compile: ('styleName\	^ ''', aName, '''') withCRs
		classified: #accessing! !

!SystemSettingBrowser methodsFor: 'UI' stamp: 'alain.plantec 3/27/2009 13:45'!
buildWindowIn: aWindow verticalGap: startGap 
	| menuBar menuBarY |
	menuBar := self menuBarIn: aWindow.
	menuBarY := menuBar minExtent y.
	aWindow 
		addMorph: menuBar
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ startGap corner: 0 @ menuBarY)).
	^ super 
		buildWindowIn: aWindow
		verticalGap: menuBarY + startGap! !

!SystemSettingBrowser methodsFor: 'UI' stamp: 'alain.plantec 3/24/2009 16:57'!
configurationMenuIn: aWindow
	| configurationMenu |
	configurationMenu := aWindow newMenu.
	configurationMenu
		addToggle: 'Browse internal settings' translated
		target: self
		selector: #browseInternalSettings.
	configurationMenu lastItem font: aWindow theme menuFont.
	configurationMenu
		addToggle: 'Build default style' translated
		target: self
		selector: #buildDefaultStyle.
	configurationMenu lastItem font: aWindow theme menuFont.
	^ configurationMenu! !

!SystemSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/20/2009 14:42'!
defaultSettingStyleClass
	^ Smalltalk at: self defaultSettingStyleClassName ifAbsent: []! !

!SystemSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/20/2009 14:42'!
defaultSettingStyleClassName
	^ #DefaultSettingStyle! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
exampleText
	^ 'The simplest:
Definition of the boolean setting "newbyMode" with only a label and a default value:
------------------
MyClass class>>newbyMode
	<setting>
	^ NewbyMode 
			ifNil: [NewbyMode := 
							(SettingManager newSetting: ''Newby mode'') 
							default: false].
------------------
						
One can add a helpful description: 			
------------------
MyClass class>>newbyMode
	<setting>
	^ NewbyMode 
			ifNil: [NewbyMode := 
							(SettingManager newSetting: ''Newby mode'') 
							default: false].
------------------

Classify a bit more:
Settings are organized as a tree. Each setting can be used as the parent of another setting.
The simplest way is to use an empty node (that is a node with no setting) and to define some settings 
with this empty node as a parent.

Here is an empty node "uiSettingNode". Note that there is no need for a class variable.
------------------
MyClass class>>uiSettingNode
	<setting>
	^ (SettingManager newNode: ''UI'') description: ''User interface settings'' 
------------------
and a child setting for it:
------------------
MyClass class>>gradientButtonLook
	<setting>
	^ GradientButtonLook
		ifNil: [GradientButtonLook := 
						(SettingManager newSetting: ''Gradient look for buttons'')
						parent: #uiSettingNode;
						default: true]
------------------
'! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
examples
	"Open up a workspace with explanatory info in it about the Preference Browser"
	(Workspace new 
		contents: self exampleText;
		openLabel: 'Setting examples') extent: 800@600! !

!SystemSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/20/2009 14:42'!
getCodeText
	^ self getCurrentSelection
		ifNil: ['']
		ifNotNil: [:s | 
			| code | 
			code := s item realReceiver class
						sourceCodeAt: s item selector 
						ifAbsent: [''].
			code
				ifEmpty: [''] 
				ifNotEmpty: [s item receiver name , '>>' , code]]! !

!SystemSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:27'!
getDescription
	^ self getCurrentSelection
		ifNil: [super getDescription]
		ifNotNil: [:selection | Text
				streamContents: [:s |
					s nextPutAll: super getDescription.
					(selection item value respondsTo: #defaultValue)
						ifTrue: [s nextPut: Character cr;
								 nextPutAll: 'Default: ['.
								 selection item value defaultValue settingStoreOn: s.
								 s nextPut: $]]]]! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
help
	"Open up a workspace with explanatory info in it about the Preference Browser"
	Workspace new
		contents: self helpText;
		openLabel: 'Settings help'! !

!SystemSettingBrowser methodsFor: 'UI' stamp: 'alain.plantec 3/24/2009 16:57'!
helpMenuIn: aWindow
	| helpMenu |
	helpMenu := aWindow newMenu.
	helpMenu
		addToggle: 'About' translated
		target: self
		selector: #about.
	helpMenu lastItem font: aWindow theme menuFont.
	helpMenu
		addToggle: 'Help' translated
		target: self
		selector: #help.
	helpMenu lastItem font: aWindow theme menuFont.
	helpMenu
		addToggle: 'Examples' translated
		target: self
		selector: #examples.
	helpMenu lastItem font: aWindow theme menuFont.
	^ helpMenu
! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
helpText
	^ 'To be set later'! !

!SystemSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/20/2009 16:17'!
internalSettingKeyword
	^ #internalSetting! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/30/2009 23:13'!
keyStroke: aCharacter from: aTreeMorph 
	super keyStroke: aCharacter from: aTreeMorph.
	(self getCurrentSelection)
		ifNotNil: [:current | 
			current item value haveDefault
				ifTrue: [aCharacter = $d
						ifTrue: [^ self menuSetToDefault: current]].
			current item value haveEditableList
				ifTrue: [aCharacter = $e
						ifTrue: [^ self menuEmptyList: current]]]! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/31/2009 09:28'!
loadStyle
	| allStyleClasses cls |
	allStyleClasses := (SettingStyle allSubclasses
				asSortedCollection: [:a :b | a name < b name]) asOrderedCollection.
	cls := UIManager default
				chooseFrom: (allStyleClasses
						collect: [:c | c styleName])
				values: allStyleClasses.
	cls
		ifNotNil: [cls new loadStyleFrom: self. self changed: #getDescription]! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/30/2009 23:18'!
menu: menu shifted: b 
	super menu: menu shifted: b.
	(self getCurrentSelection)
		ifNotNil: [:current | 
			current item value haveDefault
				ifTrue: [menu
						add: 'Set to default (d)' translated
						target: self
						selector: #menuSetToDefault:
						argument: current].
			current item value haveEditableList
				ifTrue: [menu
						add: 'Empty list (e)' translated
						target: self
						selector: #menuEmptyList:
						argument: current]].
	^ menu! !

!SystemSettingBrowser methodsFor: 'UI' stamp: 'alain.plantec 3/24/2009 16:57'!
menuBarIn: aWindow
	| menuBar |
	menuBar := aWindow newToolDockingBar.
	menuBar
		add: 'Style' translated
		font: aWindow theme menuBarFont
		icon: nil
		help: 'Style creation, loading or removal operations' translated
		subMenu: (self styleMenuIn: aWindow).
	menuBar
		add: 'Configuration' translated
		font: aWindow theme menuBarFont
		icon: nil
		help: nil
		subMenu: (self configurationMenuIn: aWindow).
	menuBar addSpacer.
	menuBar
		add: 'Help' translated
		font: aWindow theme menuBarFont
		icon: nil
		help: nil
		subMenu: (self helpMenuIn: aWindow).
	^ menuBar
! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/30/2009 23:15'!
menuEmptyList: aTreeNode
	| v |
	(v := aTreeNode item value) haveEditableList ifTrue: [v emptyList]! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/30/2009 23:25'!
menuSetToDefault: aTreeNode
	| v |
	(v := aTreeNode item value) haveDefault
		ifTrue: [(self confirm: 'Set to default value ?' translated)
				ifTrue: [v setToDefault]] ! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/30/2009 21:32'!
newStyle
	| name clsName usedName |
	name := UIManager default request: 'Give the new style name.' translated initialAnswer: 'MyOwn'.
	name
		ifNotEmpty: [
			usedName := ''.
			name subStrings do: [:s | s at: 1 put: (s first asUppercase). usedName := usedName, s].
			clsName := ((usedName
						, (self class styleNameClassSuffix value)) asIdentifier: true) asSymbol.
			(Smalltalk
						at: clsName
						ifAbsent: [])
				ifNotNil: [:cls | World alert: clsName , ' ' , 'already exists, sorry' translated title: 'Invalid new style name' translated].
			self buildUserDefinedStyleNamed: name classname: clsName code: (self styleLoadCode: false)]! !

!SystemSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 23:27'!
newTreeBuilder
	^ super newTreeBuilder acceptableKeywords: #('setting' )! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
removeStyle
	| allStyleClasses cls |
	allStyleClasses := (SettingStyle allSubclasses asSortedCollection: [:a :b | a name < b name]) asOrderedCollection.
	allStyleClasses remove: self defaultSettingStyleClass.
	cls := UIManager default chooseFrom: (allStyleClasses collect: [:c | c styleName]) values: allStyleClasses.
	cls ifNotNil: [(UIManager confirm: 'Definitively remove style' translated,' "', cls styleName, '" ?')
		ifTrue: [Smalltalk removeClassNamed: cls name]]! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/31/2009 09:27'!
styleLoadCode: forDefault 
	^ String
		streamContents: [:s | 
			s nextPutAll: 'load';
				 nextPut: Character cr.
			(self treeBuilder collector
				select: [:d | d value hasValue])
				do: [:d | 
					s nextPut: $[;
						 nextPutAll: d receiver name;
						 nextPut: Character space;
						 nextPutAll: d selector; 
						 nextPut: Character space;
						 nextPutAll: 'value: ';
						 nextPut: Character space.
					forDefault
						ifTrue: [d value defaultValue settingStoreOn: s]
						ifFalse: [d value value settingStoreOn: s].
					s nextPut: $];
						 nextPutAll: ' on: Error do: [|message| message := ''Error while loading ' , d receiver name , '>>' , d selector , ' setting''.
						status ifNotNil: [status nextPutAll: message; cr] ifNil: [Transcript show: message, String cr]]';
						 nextPut: $.;
						 cr]]! !

!SystemSettingBrowser methodsFor: 'UI' stamp: 'alain.plantec 3/24/2009 16:58'!
styleMenuIn: aWindow
	| styleMenu |
	styleMenu := aWindow newMenu.
	styleMenu
		addToggle: 'New' translated
		target: self
		selector: #newStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	styleMenu
		addToggle: 'Update' translated
		target: self
		selector: #updateStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	styleMenu
		addToggle: 'Load' translated
		target: self
		selector: #loadStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	styleMenu
		addToggle: 'Browse' translated
		target: self
		selector: #browseStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	styleMenu
		addToggle: 'remove' translated
		target: self
		selector: #removeStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	^ styleMenu! !

!SystemSettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/20/2009 14:42'!
taskbarIcon
	^ MenuIcons smallConfigurationIcon! !

!SystemSettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
updateStyle
	| allStyleClasses cls |
	allStyleClasses := (SettingStyle allSubclasses asSortedCollection: [:a :b | a name < b name]) asOrderedCollection.
	cls := UIManager default chooseFrom: (allStyleClasses collect: [:c | c styleName]) values: allStyleClasses.
	cls ifNotNil: [self buildUserDefinedStyleNamed: cls styleName classname: cls name code: (self styleLoadCode: false)]! !

!SettingBrowser class methodsFor: 'opening' stamp: 'alain.plantec 3/30/2009 21:26'!
forKeywords: aCollectionOfRegExps 
	^ self new acceptableKeywords: aCollectionOfRegExps! !

!SettingBrowser class methodsFor: 'opening' stamp: 'alain.plantec 3/27/2009 13:04'!
open
	^ self new open! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 21:25'!
acceptableKeywords: aCollectionOfRegExps 
	self treeBuilder acceptableKeywords: aCollectionOfRegExps ! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/31/2009 09:14'!
addToStatus: aText 
	status nextPutAll: aText.
! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 3/30/2009 10:18'!
applyFilters
	| filter |
	self searchedText
		ifNotEmpty: [filter := SettingSearchTokenFilter new token: self searchedText.
			self updateAccordingTo: filter].
	self updateList! !

!SettingBrowser methodsFor: 'UI' stamp: 'alain.plantec 3/24/2009 09:10'!
buildWindowIn: aWindow
	^ self buildWindowIn: aWindow verticalGap: 0 
! !

!SettingBrowser methodsFor: 'UI' stamp: 'alain.plantec 3/30/2009 10:27'!
buildWindowIn: aWindow verticalGap: startGap 
	| statusView toolBar treeMorph toolBarY gap localGap |
	treeMorph := self treeMorphIn: aWindow.
	statusView := self statusViewIn: aWindow.
	toolBar := self toolBarIn: aWindow.
	localGap := 5.
	gap := startGap + localGap.
	toolBarY := toolBar minExtent y + gap.
	aWindow 
		addMorph: toolBar
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ (gap ) corner: 0 @ (toolBarY + localGap))).
	aWindow 
		addMorph: treeMorph
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0.99)
				offsets: (0 @ (toolBarY + localGap + localGap) corner: 0 @ 100 negated)).
	aWindow 
		addMorph: statusView
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0.99 corner: 1 @ 1)
				offsets: (0 @ 100 negated corner: 0 @ 0)).
	^ aWindow! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 3/23/2009 18:38'!
changeSearchedText: aString 
	| |
	self searchedText ~= aString ifTrue: [
	self searchedText: aString.
	roots := nil.
	self applyFilters].
	^ true! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 3/23/2009 18:38'!
expandAll
	self changed: #(#roots #expandAll).
! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 3/26/2009 14:51'!
forceRebuild
		roots := nil.
		self noteNewSelection: nil.
		self updateList! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 10:34'!
getDescription
	^ self getCurrentSelection
		ifNil: [status contents]
		ifNotNil: [:selection | selection description]! !

!SettingBrowser methodsFor: 'initializing' stamp: 'alain.plantec 3/23/2009 18:38'!
initialize
	super initialize.
	status := '' writeStream.
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 16:04'!
itemSortBlock
		^ [:a :b | a value name < b value name]
! !

!SettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/23/2009 18:38'!
keyStroke: aCharacter from: aTreeMorph 
	self getCurrentSelection
		ifNotNil: [:current | current keyStroke: aCharacter from: aTreeMorph]! !

!SettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 3/23/2009 18:38'!
menu: menu shifted: b 
	"Set up the menu to apply to the receiver's, 
	honoring the #shifted boolean"
	self getCurrentSelection ifNotNil: [:current | current menu: menu shifted: b].
	^ menu! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 22:26'!
newTreeBuilder
	^ SettingTreeBuilder new client: self; handlerClass: SettingHandler! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 3/23/2009 18:38'!
noteNewSelection: aSelection
	super noteNewSelection: aSelection.
	self changed: #getDescription.
	! !

!SettingBrowser methodsFor: 'UI' stamp: 'alain.plantec 3/27/2009 13:44'!
open
	| window |
	Cursor wait
		showWhile: [window := StandardWindow new model: self.
			window title: 'Setting tree'.
			self buildWindowIn: window.
			window themeChanged.
			window openInWorld.
			^ window]! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/27/2009 23:04'!
pragmaErrorOccured: aPragmaError
	self setDescription: aPragmaError message, String cr! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/27/2009 23:02'!
prepareCollector
	self collector whenChangedSend: #forceRebuild to: self.
	self collector announcer on: PragmaWithError send: #pragmaErrorOccured: to: self
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 21:15'!
receiver: anObject
	self treeBuilder receiver: anObject! !

!SettingBrowser methodsFor: 'dependents access' stamp: 'alain.plantec 3/30/2009 21:30'!
release
	treeBuilder release.
	treeBuilder := nil.
	roots := nil.
	status := nil.
	searchedText := nil.
	super release.! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 21:52'!
roots
	^ roots ifNil: [roots := self treeBuilder buildTree]
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:38'!
searchedText
	^ searchedText ifNil: [searchedText := '']! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:38'!
searchedText: aString
	searchedText := aString.
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/31/2009 09:14'!
setDescription: aText 
	status reset.
	self addToStatus: aText.
	self changed: #getDescription! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/31/2009 09:29'!
status
	^ status! !

!SettingBrowser methodsFor: 'UI' stamp: 'alain.plantec 3/23/2009 18:38'!
statusViewIn: aMorph
	| statusView |
	statusView := aMorph
				newTextEditorFor: self
				getText: #getDescription
				setText: #setDescription:.
	^ statusView
 ! !

!SettingBrowser methodsFor: 'UI' stamp: 'alain.plantec 3/30/2009 10:24'!
toolBarIn: aMorph
	| toolBar |
	toolBar := aMorph newToolbar: {
	aMorph newToolSpacer.
	aMorph
		newButtonFor: self
		getState: nil
		action: #expandAll
		arguments: nil
		getEnabled: nil
		label: 'Expand all' translated
		help: 'Expand all tree nodes' translated.
	aMorph newToolSpacer.
	aMorph newLabel: 'Search: ' translated.
	aMorph
				newTextEntryFor: self
				getText: #searchedText
				setText: #changeSearchedText:
				getEnabled: nil
				help: nil.
	aMorph newToolSpacer}.

	^ toolBar
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 21:50'!
treeBuilder
	^ treeBuilder
		ifNil: [treeBuilder := self newTreeBuilder]! !

!SettingBrowser methodsFor: 'UI' stamp: 'alain.plantec 3/30/2009 22:03'!
treeMorphIn: aMorph
	| treeMorph |
	treeMorph := MorphTreeMorph new selectionColor: aMorph theme selectionColor;	
				on: self
				list: #roots
				selected: #getCurrentSelection
				changeSelected: #noteNewSelection:
				menu: #menu:shifted:
				keystroke: #keyStroke:from:;
				 cornerStyle: aMorph preferredCornerStyle;
				borderStyle: (BorderStyle inset width: 1);
				 hResizing: #spaceFill;
				 vResizing: #spaceFill;
				 autoDeselect: true;
				 yourself.
	treeMorph columns: {self treeBuilder maxNameWidth + 30}.
	^ treeMorph
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/30/2009 21:41'!
treeNodeClass
	^ SettingTreeNode! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 3/30/2009 10:21'!
updateAccordingTo: aFilter 
	self roots do: [ :r | r updateAccordingTo: aFilter ].
	self roots removeAllSuchThat: [ :n | n isEmpty and: [ (aFilter keepHandler: n item) not ] ].
! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 3/30/2009 10:28'!
updateList
	self changed: #roots.
	self changed: #getDescription.
	

	
! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 3/23/2009 18:38'!
updateStatusWith: aMessage
	status nextPutAll: aMessage.
	status nextPut: Character cr.
! !
